'use strict';

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var path = require('path');
var licenses = require('@rexxars/choosealicense-list');
var gitRemoteOriginUrl = require('git-remote-origin-url');
var cli = require('./cli-dbe00b65.js');
var xdgBasedir = require('xdg-basedir');
var gitUserInfo = require('git-user-info');
var emailValidator = require('email-validator');
var _package$1 = require('./package-bdb22a22.js');
var getIt = require('get-it');
var middleware = require('get-it/middleware');
var _package = require('./package-f79f12a7.js');
var outdent = require('outdent');
var chalk = require('chalk');
function _interopDefaultCompat(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    default: e
  };
}
var path__default = /*#__PURE__*/_interopDefaultCompat(path);
var licenses__default = /*#__PURE__*/_interopDefaultCompat(licenses);
var gitRemoteOriginUrl__default = /*#__PURE__*/_interopDefaultCompat(gitRemoteOriginUrl);
var xdgBasedir__default = /*#__PURE__*/_interopDefaultCompat(xdgBasedir);
var getIt__default = /*#__PURE__*/_interopDefaultCompat(getIt);
var outdent__default = /*#__PURE__*/_interopDefaultCompat(outdent);
var chalk__default = /*#__PURE__*/_interopDefaultCompat(chalk);
const request = getIt__default.default([middleware.promise({
  onlyBody: true
}), middleware.jsonRequest(), middleware.jsonResponse(), middleware.httpErrors(), middleware.headers({
  "User-Agent": "".concat(_package.pkg.name, "@").concat(_package.pkg.version)
})]);
async function getUserInfo(_ref, pkg) {
  var _flags$author;
  let {
    requireUserConfirmation,
    flags
  } = _ref;
  const userInfo = getPackageUserInfo({
    author: (_flags$author = flags.author) !== null && _flags$author !== void 0 ? _flags$author : pkg == null ? void 0 : pkg.author
  }) || (await getSanityUserInfo()) || (await getGitUserInfo());
  if (requireUserConfirmation) {
    return promptForInfo(userInfo);
  }
  return userInfo;
}
function getPackageUserInfo(pkg) {
  let author = pkg == null ? void 0 : pkg.author;
  if (!author) {
    return void 0;
  }
  if (author && typeof author !== "string") {
    return author;
  } else if (!author.includes("@")) {
    return {
      name: author
    };
  }
  const [pre, ...post] = author.replace(/[<>[\]]/g, "").split(/@/);
  const nameParts = pre.split(/\s+/);
  const email = [nameParts[nameParts.length - 1], ...post].join("@");
  const name = nameParts.slice(0, -1).join(" ");
  return {
    name,
    email
  };
}
async function promptForInfo(defValue) {
  const name = await _package$1.prompt("Author name", {
    filter: filterString,
    default: defValue && defValue.name,
    validate: requiredString
  });
  const email = await _package$1.prompt("Author email", {
    filter: filterString,
    default: defValue && defValue.email,
    validate: validOrEmptyEmail
  });
  return {
    name,
    email
  };
}
async function getSanityUserInfo() {
  try {
    var _xdgBasedir__default$;
    const data = await _package$1.readJsonFile(path__default.default.join((_xdgBasedir__default$ = xdgBasedir__default.default.config) !== null && _xdgBasedir__default$ !== void 0 ? _xdgBasedir__default$ : "", "sanity", "config.json"));
    const token = data == null ? void 0 : data.authToken;
    if (!token) {
      return void 0;
    }
    const user = await request({
      url: "https://api.sanity.io/v1/users/me",
      headers: {
        Authorization: "Bearer ".concat(token)
      }
    });
    if (!user) {
      return void 0;
    }
    const {
      name,
      email
    } = user;
    return {
      name,
      email
    };
  } catch (err) {
    return void 0;
  }
}
async function getGitUserInfo() {
  const user = await gitUserInfo.getGitUserInfo();
  return user ? {
    name: user.name,
    email: user.email
  } : void 0;
}
function filterString(val) {
  return (val || "").trim();
}
function requiredString(value) {
  return value.length > 1 ? true : "Required";
}
function validOrEmptyEmail(value) {
  if (!value) {
    return true;
  }
  return emailValidator.validate(value) ? true : "Must either be a valid email or empty";
}
function generateReadme(data) {
  const {
    user,
    pluginName,
    license,
    description
  } = data;
  return outdent__default.default(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    # ", "\n\n    ", "\n\n    ", "\n\n    ## Usage\n\n    Add it as a plugin in `sanity.config.ts` (or .js):\n\n    ```ts\n    import {defineConfig} from 'sanity'\n    import {myPlugin} from '", "'\n\n    export default defineConfig({\n      //...\n      plugins: [myPlugin({})],\n    })\n    ```\n\n    ", "\n    ", "\n  "], ["\n    # ", "\n\n    ", "\n\n    ", "\n\n    ## Usage\n\n    Add it as a plugin in \\`sanity.config.ts\\` (or .js):\n\n    \\`\\`\\`ts\n    import {defineConfig} from 'sanity'\n    import {myPlugin} from '", "'\n\n    export default defineConfig({\n      //...\n      plugins: [myPlugin({})],\n    })\n    \\`\\`\\`\n\n    ", "\n    ", "\n  "])), pluginName, v3BannerNotice(), installationSnippet(pluginName !== null && pluginName !== void 0 ? pluginName : "unknown"), pluginName, getLicenseText(license == null ? void 0 : license.id, (user == null ? void 0 : user.name) ? user : void 0), developTestSnippet()) + "\n";
}
function v3BannerNotice() {
  return "> This is a **Sanity Studio v3** plugin.";
}
function installationSnippet(packageName) {
  return outdent__default.default(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    ## Installation\n\n    ```sh\n    npm install ", "\n    ```\n    "], ["\n    ## Installation\n\n    \\`\\`\\`sh\n    npm install ", "\n    \\`\\`\\`\n    "])), packageName);
}
function developTestSnippet() {
  return outdent__default.default(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    ## Develop & test\n\n    This plugin uses [@sanity/plugin-kit](https://github.com/sanity-io/plugin-kit)\n    with default configuration for build & watch scripts.\n\n    See [Testing a plugin in Sanity Studio](https://github.com/sanity-io/plugin-kit#testing-a-plugin-in-sanity-studio)\n    on how to run this plugin with hotreload in the studio.\n  "])));
}
function getLicenseText(licenseId, user) {
  if (!licenseId) {
    return "";
  }
  let licenseName = licenses__default.default.find(licenseId).title;
  licenseName = licenseName == null ? void 0 : licenseName.replace(/\s+license$/i, "");
  let licenseText = "## License\n";
  if (licenseName && (user == null ? void 0 : user.name)) {
    licenseText = "".concat(licenseText, "\n[").concat(licenseName, "](LICENSE) \xA9 ").concat(user == null ? void 0 : user.name, "\n");
  } else if (licenseName) {
    licenseText = "".concat(licenseText, "\n[").concat(licenseName, "](LICENSE)\n");
  } else {
    licenseText = "".concat(licenseText, "\nSee [LICENSE](LICENSE)");
  }
  return licenseText;
}
function isDefaultGitHubReadme(readme) {
  if (!readme) {
    return false;
  }
  const lines = readme.split("\n", 20).filter(Boolean);
  return lines.length <= 2 && lines[0].startsWith("#");
}
const semverWorkflowPreset = {
  name: "semver-workflow",
  description: "Files and dependencies for conventional-commits, github workflow and semantic-release.",
  apply: applyPreset$3
};
const info = function (write, msg) {
  for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }
  return write && cli.log.info(msg, ...args);
};
async function applyPreset$3(options) {
  await writeAssets(semverWorkflowFiles(), options);
  await addPrepareScript(options);
  await addDevDependencies$2(options);
  await updateReadme(options);
}
async function addPrepareScript(options) {
  const pkg = await _package$1.getPackage(options);
  const didWrite = await _package$1.addPackageJsonScripts(pkg, options, scripts => {
    scripts.prepare = _package$1.addScript("husky install", scripts.prepare);
    return scripts;
  });
  info(didWrite, "Added prepare script to package.json");
}
async function addDevDependencies$2(options) {
  const pkg = await _package$1.getPackage(options);
  const devDeps = _package$1.sortKeys(_objectSpread(_objectSpread({}, pkg.devDependencies), await semverWorkflowDependencies()));
  const newPkg = _objectSpread({}, pkg);
  newPkg.devDependencies = devDeps;
  await _package$1.writePackageJsonDirect(newPkg, options);
  cli.log.info("Updated devDependencies.");
  cli.log.info(chalk__default.default.green(outdent__default.default(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n        semantic-release preset injected.\n\n        Please confer\n        https://github.com/sanity-io/plugin-kit/blob/main/docs/semver-workflow.md#manual-steps-after-inject\n        to finalize configuration for this preset.\n  "]))).trim()));
}
async function updateReadme(options) {
  var _await$_package$1$rea;
  const {
    basePath
  } = options;
  const readmePath = path__default.default.join(basePath, "README.md");
  const readme = (_await$_package$1$rea = await _package$1.readFile(readmePath, "utf8").catch(_package$1.errorToUndefined)) !== null && _await$_package$1$rea !== void 0 ? _await$_package$1$rea : "";
  const {
    v3Banner,
    install,
    usage,
    developTest,
    license,
    releaseSnippet
  } = await readmeSnippets(options);
  const prependSections = missingSections(readme, [v3Banner, install, usage]);
  const appendSections = missingSections(readme, [license, developTest, releaseSnippet]);
  if (prependSections.length || appendSections.length) {
    const updatedReadme = [...prependSections, readme, ...appendSections].filter(Boolean).join("\n\n");
    await _package$1.writeFile(readmePath, updatedReadme, {
      encoding: "utf8"
    });
    cli.log.info("Updated README. Please review the changes.");
  }
}
async function readmeSnippets(options) {
  var _pkg$name;
  const pkg = await _package$1.getPackage(options);
  const user = await getUserInfo(options, pkg);
  const bestEffortUrl = readmeBaseurl(pkg);
  const install = installationSnippet((_pkg$name = pkg.name) !== null && _pkg$name !== void 0 ? _pkg$name : "unknown");
  const usage = outdent__default.default(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n    ## Usage\n  "])));
  const license = getLicenseText(typeof pkg.license === "string" ? pkg.license : void 0, user);
  const releaseSnippet = outdent__default.default(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n    ### Release new version\n\n    Run [\"CI & Release\" workflow](", "/actions/workflows/main.yml).\n    Make sure to select the main branch and check \"Release new version\".\n\n    Semantic release will only release on configured branches, so it is safe to run release on any branch.\n  "])), bestEffortUrl);
  return {
    v3Banner: v3BannerNotice(),
    install,
    usage,
    license,
    developTest: developTestSnippet(),
    releaseSnippet
  };
}
function missingSections(readme, sections) {
  return sections.filter(section => !closeEnough(section, readme));
}
function closeEnough(a, b) {
  const aLines = a.split("\n");
  const bLines = b.split("\n");
  const matchingLines = aLines.filter(line => bLines.find(bLine => bLine === line)).length;
  const isCloseEnough = matchingLines >= aLines.length * 0.5;
  return isCloseEnough;
}
function semverWorkflowFiles() {
  const base = [{
    type: "copy",
    from: [".github", "workflows", "main.yml"],
    to: [".github", "workflows", "main.yml"]
  }, {
    type: "copy",
    from: [".husky", "commit-msg"],
    to: [".husky", "commit-msg"]
  }, {
    type: "copy",
    from: [".husky", "pre-commit"],
    to: [".husky", "pre-commit"]
  }, {
    type: "copy",
    from: [".releaserc.json"],
    to: ".releaserc.json"
  }, {
    type: "copy",
    from: ["npmrc"],
    to: ".npmrc"
  }, {
    type: "copy",
    from: ["commitlint.template.js"],
    to: "commitlint.config.js"
  }, {
    type: "copy",
    from: ["lint-staged.template.js"],
    to: "lint-staged.config.js"
  }];
  return base.map(fromTo => {
    if (fromTo.type === "copy") {
      return _objectSpread(_objectSpread({}, fromTo), {}, {
        from: ["semver-workflow", ...fromTo.from]
      });
    }
    return fromTo;
  });
}
async function semverWorkflowDependencies() {
  return _package$1.resolveLatestVersions(["@commitlint/cli", "@commitlint/config-conventional", "@sanity/semantic-release-preset", "husky", "lint-staged"]);
}
function readmeBaseurl(pkg) {
  var _ref2, _ref3;
  var _a;
  return ((_ref2 = (_ref3 = (_a = pkg.repository) == null ? void 0 : _a.url) !== null && _ref3 !== void 0 ? _ref3 : pkg.homepage) !== null && _ref2 !== void 0 ? _ref2 : "TODO").replace(/.+:\/\//g, "https://").replace(/\.git/g, "").replace(/git@github.com\//g, "github.com/").replace(/git@github.com:/g, "https://github.com/").replace(/#.+/g, "");
}
const renovatePreset = {
  name: "renovatebot",
  description: "Files to enable renovatebot.",
  apply: applyPreset$2
};
async function applyPreset$2(options) {
  await writeAssets([{
    type: "copy",
    from: ["renovatebot", "renovate.json"],
    to: "renovate.json"
  }], options);
}
const ui = {
  name: "ui",
  description: "`@sanity/ui` and dependencies",
  apply: applyPreset$1
};
async function applyPreset$1(options) {
  await addDependencies(options);
  await addDevDependencies$1(options);
  cli.log.info(chalk__default.default.green("ui preset injected"));
}
async function addDependencies(options) {
  const pkg = await _package$1.getPackage(options);
  const newDeps = _package$1.sortKeys(_package$1.forceDependencyVersions(_objectSpread(_objectSpread({}, pkg.dependencies), await resolveDependencyList()), _package$1.forcedPackageVersions));
  const newPkg = _objectSpread({}, pkg);
  newPkg.dependencies = newDeps;
  await _package$1.writePackageJsonDirect(newPkg, options);
  cli.log.info("Updated dependencies.");
}
async function addDevDependencies$1(options) {
  const pkg = await _package$1.getPackage(options);
  const newDeps = _package$1.sortKeys(_package$1.forceDependencyVersions(_objectSpread(_objectSpread({}, pkg.devDependencies), await resolveDevDependencyList()), _package$1.forcedDevPackageVersions));
  const newPkg = _objectSpread({}, pkg);
  newPkg.devDependencies = newDeps;
  await _package$1.writePackageJsonDirect(newPkg, options);
  cli.log.info("Updated devDependencies.");
}
async function resolveDependencyList() {
  return _package$1.resolveLatestVersions(["@sanity/icons", "@sanity/ui"]);
}
async function resolveDevDependencyList() {
  return _package$1.resolveLatestVersions(["react", "react-dom", "react-is", "styled-components"]);
}
const uiWorkshop = {
  name: "ui-workshop",
  description: "Files for testing custom components with @sanity/ui-workshop",
  apply: applyPreset
};
async function applyPreset(options) {
  await writeAssets(files(), options);
  await addDevDependencies(options);
  await updateGitIgnore(options);
  cli.log.info(chalk__default.default.green(outdent__default.default(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n        ui-workshop preset injected.\n\n        Please confer\n        https://github.com/sanity-io/plugin-kit/blob/main/docs/ui-workshop.md#manual-steps-after-inject\n        to finalize configuration for this preset.\n  "]))).trim()));
}
function files() {
  const base = [{
    type: "copy",
    from: ["workshop.config.ts"],
    to: ["workshop.config.ts"]
  }, {
    type: "copy",
    from: ["src", "CustomField.tsx"],
    to: ["src", "CustomField.tsx"]
  }, {
    type: "copy",
    from: ["src", "__workshop__", "index.tsx"],
    to: ["src", "__workshop__", "index.tsx"]
  }, {
    type: "copy",
    from: ["src", "__workshop__", "props.tsx"],
    to: ["src", "__workshop__", "props.tsx"]
  }];
  return base.map(fromTo => {
    if (fromTo.type === "copy") {
      return _objectSpread(_objectSpread({}, fromTo), {}, {
        from: ["ui-workshop", ...fromTo.from]
      });
    }
    return fromTo;
  });
}
async function updateGitIgnore(options) {
  var _await$_package$1$rea2;
  const {
    basePath
  } = options;
  const gitignorePath = path__default.default.join(basePath, ".gitignore");
  let gitignore = (_await$_package$1$rea2 = await _package$1.readFile(gitignorePath, "utf8").catch(_package$1.errorToUndefined)) !== null && _await$_package$1$rea2 !== void 0 ? _await$_package$1$rea2 : "";
  const value = ".workshop";
  if (gitignore.includes(value)) {
    return;
  }
  gitignore += "\n\n".concat(value);
  await _package$1.writeFile(gitignorePath, gitignore, {
    encoding: "utf8"
  });
}
async function addDevDependencies(options) {
  const pkg = await _package$1.getPackage(options);
  const devDeps = _package$1.sortKeys(_objectSpread(_objectSpread({}, pkg.devDependencies), await devDependencies()));
  const newPkg = _objectSpread({}, pkg);
  newPkg.devDependencies = devDeps;
  await _package$1.writePackageJsonDirect(newPkg, options);
  cli.log.info("Updated devDependencies.");
}
async function devDependencies() {
  return _package$1.resolveLatestVersions(["@sanity/ui-workshop", "@sanity/icons", "@sanity/ui", "react", "react-dom", "styled-components"]);
}
const presets = [semverWorkflowPreset, renovatePreset, ui, uiWorkshop];
const presetNames = presets.map(p => p == null ? void 0 : p.name);
function presetHelpList(padStart) {
  return presets.map(p => "".concat("".padStart(padStart)).concat(p.name.padEnd(20)).concat(p.description)).join("\n");
}
async function injectPresets(options) {
  var _a;
  if (options.flags.presetOnly && !((_a = options.flags.preset) == null ? void 0 : _a.length)) {
    throw new Error("--preset-only, but no --preset [preset-name] was provided.");
  }
  const applyPresets = presetsFromInput(options.flags.preset);
  for (const preset of applyPresets) {
    await preset.apply(options);
  }
}
function presetsFromInput(inputPresets) {
  if (!inputPresets) {
    return [];
  }
  const unknownPresets = inputPresets.filter(p => !presetNames.includes(p));
  if (unknownPresets.length) {
    throw new Error("Unknown --preset(s): [".concat(unknownPresets.join(", "), "]. Must be one of: [").concat(presetNames.join(", "), "]"));
  }
  return inputPresets.filter(onlyUnique).map(presetName => presets.find(p => p.name === presetName)).filter(p => !!p);
}
function onlyUnique(value, index, arr) {
  return arr.indexOf(value) === index;
}
function tsconfigTemplate(options) {
  const {
    flags
  } = options;
  return {
    type: "template",
    force: flags.force,
    to: "tsconfig.json",
    value: outdent.outdent(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n      {\n        \"extends\": \"./tsconfig.settings\",\n        \"include\": [\"./src\", \"./package.config.ts\"],\n        \"compilerOptions\": {\n          \"rootDir\": \".\",\n          \"jsx\": \"react-jsx\",\n          \"noEmit\": true\n        }\n      }\n    "])))
  };
}
function tsconfigTemplateDist(options) {
  const {
    flags,
    outDir
  } = options;
  return {
    type: "template",
    force: flags.force,
    to: "tsconfig.".concat(outDir, ".json"),
    value: outdent.outdent(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n      {\n        \"extends\": \"./tsconfig.settings\",\n        \"include\": [\"./src\"],\n        \"exclude\": [\n          \"./src/**/__fixtures__\",\n          \"./src/**/__mocks__\",\n          \"./src/**/*.test.ts\",\n          \"./src/**/*.test.tsx\"\n        ],\n        \"compilerOptions\": {\n          \"rootDir\": \".\",\n          \"outDir\": \"./", "\",\n          \"jsx\": \"react-jsx\",\n          \"emitDeclarationOnly\": true\n        }\n      }\n    "])), outDir)
  };
}
function tsconfigTemplateSettings(options) {
  const {
    flags
  } = options;
  return {
    type: "template",
    force: flags.force,
    to: "tsconfig.settings.json",
    value: outdent.outdent(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n      {\n        \"compilerOptions\": {\n          \"moduleResolution\": \"node\",\n          \"target\": \"esnext\",\n          \"module\": \"esnext\",\n          \"lib\": [\"DOM\", \"DOM.Iterable\", \"ESNext\"],\n          \"esModuleInterop\": true,\n          \"strict\": true,\n          \"downlevelIteration\": true,\n          \"declaration\": true,\n          \"allowSyntheticDefaultImports\": true,\n          \"skipLibCheck\": true,\n          \"isolatedModules\": true\n        }\n      }\n    "])))
  };
}
function pkgConfigTemplate(options) {
  const {
    flags,
    outDir
  } = options;
  return {
    type: "template",
    force: flags.force,
    to: flags.typescript ? "package.config.ts" : "package.config.js",
    value: outdent.outdent(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral(["\n      import {defineConfig} from '@sanity/pkg-utils'\n\n      export default defineConfig({\n        legacyExports: true,\n        tsconfig: 'tsconfig.", ".json',\n\n        // Remove this block to enable strict export validation\n        extract: {\n          rules: {\n            'ae-forgotten-export': 'off',\n            'ae-incompatible-release-tags': 'off',\n            'ae-internal-missing-underscore': 'off',\n            'ae-missing-release-tag': 'off',\n          },\n        },\n      })\n    "])), outDir)
  };
}
function gitignoreTemplate() {
  return {
    type: "template",
    to: ".gitignore",
    value: outdent.outdent(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral(["\n      # Logs\n      logs\n      *.log\n      npm-debug.log*\n\n      # Runtime data\n      pids\n      *.pid\n      *.seed\n\n      # Directory for instrumented libs generated by jscoverage/JSCover\n      lib-cov\n\n      # Coverage directory used by tools like istanbul\n      coverage\n\n      # nyc test coverage\n      .nyc_output\n\n      # Grunt intermediate storage (http://gruntjs.com/creating-plugins#storing-task-files)\n      .grunt\n\n      # node-waf configuration\n      .lock-wscript\n\n      # Compiled binary addons (http://nodejs.org/api/addons.html)\n      build/Release\n\n      # Dependency directories\n      node_modules\n      jspm_packages\n\n      # Optional npm cache directory\n      .npm\n\n      # Optional REPL history\n      .node_repl_history\n\n      # macOS finder cache file\n      .DS_Store\n\n      # VS Code settings\n      .vscode\n\n      # IntelliJ\n      .idea\n      *.iml\n\n      # Cache\n      .cache\n\n      # Yalc\n      .yalc\n      yalc.lock\n\n      # npm package zips\n      *.tgz\n    "])))
  };
}
function eslintrcTemplate(options) {
  const {
    flags
  } = options;
  const eslintConfig = {
    root: true,
    env: {
      node: true,
      browser: true
    },
    extends: ["sanity", flags.typescript && "sanity/typescript", "sanity/react", "plugin:react-hooks/recommended", flags.prettier && "plugin:prettier/recommended", "plugin:react/jsx-runtime"].filter(Boolean)
  };
  return {
    type: "template",
    force: flags.force,
    to: ".eslintrc",
    value: JSON.stringify(eslintConfig, null, 2)
  };
}
function eslintignoreTemplate(options) {
  const {
    flags,
    outDir
  } = options;
  const patterns = [".eslintrc.js", "commitlint.config.js", outDir, "lint-staged.config.js", flags.typescript ? "package.config.ts" : "package.config.js", flags.typescript ? "*.js" : ""].filter(Boolean);
  patterns.sort();
  return {
    type: "template",
    force: flags.force,
    to: ".eslintignore",
    value: patterns.join("\n")
  };
}
function prettierignoreTemplate(options) {
  const {
    outDir
  } = options;
  return {
    type: "template",
    to: ".prettierignore",
    value: [outDir, "pnpm-lock.yaml", "yarn.lock", "package-lock.json"].join("\n")
  };
}
const bannedFields = ["login", "description", "projecturl", "email"];
const preferredLicenses = ["MIT", "ISC", "BSD-3-Clause"];
const otherLicenses = Object.keys(licenses__default.default.list).filter(id => {
  const license = licenses__default.default.list[id];
  return !preferredLicenses.includes(id) && !bannedFields.some(field => license.body.includes("[".concat(field, "]")));
});
async function inject(options) {
  if (options.flags.presetOnly) {
    cli.log.info("Only apply presets, skipping default inject.");
  } else {
    await injectBase(options);
  }
  await injectPresets(options);
}
async function injectBase(options) {
  var _flags$name, _flags$repo;
  var _a;
  const {
    basePath,
    flags,
    requireUserConfirmation
  } = options;
  const info = function (write, msg) {
    for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
      args[_key2 - 2] = arguments[_key2];
    }
    return write && cli.log.info(msg, ...args);
  };
  const pkg = await _package$1.getPackage(options).catch(_package$1.errorToUndefined);
  cli.log.debug("Plugin has package.json: %s", pkg ? "yes" : "no");
  const user = await getUserInfo(options, pkg);
  cli.log.debug("User information: %o", user);
  const pkgName = (_flags$name = flags.name) !== null && _flags$name !== void 0 ? _flags$name : pkg == null ? void 0 : pkg.name;
  const pluginName = requireUserConfirmation || !pkgName ? await _package$1.promptForPackageName(options, pkgName) : pkgName;
  cli.log.debug("Plugin name: %s", pluginName);
  const license = await getLicense(flags, {
    user,
    pluginName,
    pkg,
    requireUserConfirmation
  });
  const licenseChanged = (pkg && pkg.license) !== (license && license.id);
  cli.log.debug("License: %s", license ? license.id : "<none>");
  const description = await getProjectDescription(basePath, pkg, requireUserConfirmation);
  cli.log.debug("Description: %s", description || "<none>");
  const repoUrl = (_flags$repo = flags.repo) !== null && _flags$repo !== void 0 ? _flags$repo : (await gitRemoteOriginUrl__default.default(basePath).catch(_package$1.errorToUndefined)) || ((_a = pkg == null ? void 0 : pkg.repository) == null ? void 0 : _a.url);
  const gitOrigin = requireUserConfirmation ? await _package$1.promptForRepoOrigin(options, repoUrl) : repoUrl;
  cli.log.debug("Remote origin: %s", gitOrigin || "<none>");
  const data = {
    user,
    pluginName,
    license,
    description,
    pkg,
    gitOrigin
  };
  let didWrite;
  const newPkg = await _package$1.writePackageJson(data, options);
  info(newPkg !== pkg, "Wrote package.json");
  data.pkg = newPkg;
  didWrite = await writeLicense(data, options, licenseChanged);
  info(didWrite, "Wrote license file (LICENSE)");
  didWrite = await writeReadme(data, options);
  info(didWrite, "Wrote readme file (README.md)");
  didWrite = await writeStaticAssets(options);
  info(didWrite.length > 0, "Wrote static asset files: %s", didWrite.join(", "));
  didWrite = await _package$1.addBuildScripts(newPkg, options);
  info(didWrite, "Added build scripts to package.json");
  didWrite = await addCompileDirToGitIgnore(data, options);
  info(didWrite, "Added compilation output directory to .gitignore");
}
async function writeReadme(data, options) {
  const {
    basePath
  } = options;
  const readmePath = path__default.default.join(basePath, "README.md");
  const readme = await _package$1.readFile(readmePath, "utf8").catch(_package$1.errorToUndefined);
  if (readme && !isDefaultGitHubReadme(readme)) {
    return false;
  }
  await _package$1.writeFileWithOverwritePrompt(readmePath, generateReadme(data), {
    encoding: "utf8",
    force: options.flags.force
  });
  return true;
}
async function writeLicense(_ref4, options, licenseChanged) {
  let {
    license
  } = _ref4;
  const {
    basePath,
    flags
  } = options;
  if (flags.license === false || !license) {
    return false;
  }
  const hasLicenseMdFile = await _package$1.fileExists(path__default.default.join(basePath, "LICENSE.md"));
  const licensePath = path__default.default.join(basePath, hasLicenseMdFile ? "LICENSE.md" : "LICENSE");
  await _package$1.writeFileWithOverwritePrompt(licensePath, license.text, {
    encoding: "utf8",
    default: licenseChanged,
    force: flags.force
  });
  return true;
}
async function getLicense(flags, _ref5) {
  let {
    user,
    pluginName,
    pkg,
    requireUserConfirmation
  } = _ref5;
  const license = await getLicenseIdentifier(flags, pkg, requireUserConfirmation);
  if (!license) {
    return void 0;
  }
  const text = license.body.replace(/\[fullname\]/g, user == null ? void 0 : user.name).replace(/\[project\]/g, pluginName).replace(/\[year\]/g, new Date().getFullYear());
  return {
    id: license.id,
    text
  };
}
async function getLicenseIdentifier(flags, pkg) {
  let requireUserConfirmation = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  if (flags.license === false) {
    return null;
  }
  if (typeof flags.license === "string") {
    const license = licenses__default.default.find("".concat(flags.license));
    if (!license) {
      throw new Error("License \"".concat(flags.license, "\" not found"));
    }
    return license;
  }
  if (pkg && pkg.license && !requireUserConfirmation) {
    const license = licenses__default.default.find("".concat(pkg.license));
    if (license) {
      return license;
    }
    cli.log.warn("package.json contains license \"".concat(pkg.license, "\", which is not recognized"));
  }
  const licenseId = await _package$1.prompt("Which license do you want to use?", {
    default: pkg && pkg.license && licenses__default.default.find(pkg.license) ? pkg.license : preferredLicenses[0],
    choices: [_package$1.prompt.separator(), ...preferredLicenses.map(value => ({
      value,
      name: licenses__default.default.list[value].title
    })), _package$1.prompt.separator(), ...otherLicenses.map(value => ({
      value,
      name: licenses__default.default.list[value].title
    }))]
  });
  return licenses__default.default.find(licenseId);
}
async function getProjectDescription(basePath, pkg) {
  var _description;
  let requireUserConfirmation = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  let description = await resolveProjectDescription(basePath, pkg);
  if (requireUserConfirmation) {
    description = await _package$1.prompt("Plugin description", {
      default: description || ""
    });
  }
  return (_description = description) !== null && _description !== void 0 ? _description : "";
}
async function resolveProjectDescription(basePath, pkg) {
  if (pkg && typeof pkg.description === "string" && pkg.description.length > 5) {
    return pkg.description;
  }
  try {
    const readmePath = path__default.default.join(basePath, "README.md");
    const readme = await _package$1.readFile(readmePath, "utf8");
    const [title, description] = readme.split("\n").filter(Boolean);
    if (!title || !description || !title.match(/^#\s+\w+/)) {
      return null;
    }
    const unlinked = description.replace(/\[(.*?)\]\(.*?\)/g, "$1");
    if (/^[^#]/.test(unlinked)) {
      return unlinked;
    }
    return null;
  } catch (err) {
    return _package$1.errorToUndefined(err);
  }
}
async function writeAssets(injectables, _ref6) {
  let {
    basePath,
    flags
  } = _ref6;
  const assetsDir = await findAssetsDir();
  const from = function () {
    for (var _len3 = arguments.length, segments = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      segments[_key3] = arguments[_key3];
    }
    return path__default.default.join(assetsDir, "inject", ...segments);
  };
  const to = function () {
    for (var _len4 = arguments.length, segments = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      segments[_key4] = arguments[_key4];
    }
    return path__default.default.join(basePath, ...segments);
  };
  const writes = [];
  for (const injectable of injectables) {
    if (injectable.type === "copy") {
      const fromPath = asArray(injectable.from);
      const toPath = asArray(injectable.to);
      if (await _package$1.copyFileWithOverwritePrompt(from(...fromPath), to(...toPath), flags)) {
        writes.push(path__default.default.join(...toPath));
      }
      continue;
    }
    if (injectable.type === "template") {
      const toPath = asArray(injectable.to);
      await _package$1.writeFileWithOverwritePrompt(to(...toPath), "".concat(injectable.value.trim(), "\n"), {
        default: "n",
        force: injectable.force || flags.force
      });
      writes.push(path__default.default.join(...toPath));
      continue;
    }
    throw new Error("Unknown operation type \"".concat(injectable.type, "\""));
  }
  return writes;
}
async function writeStaticAssets(options) {
  const {
    outDir,
    flags
  } = options;
  const files = [flags.eslint && eslintrcTemplate({
    flags: options.flags
  }), flags.eslint && eslintignoreTemplate({
    outDir,
    flags: options.flags
  }), {
    type: "copy",
    from: "editorconfig",
    to: ".editorconfig"
  }, {
    type: "copy",
    from: "sanity.json",
    to: "sanity.json"
  }, {
    type: "copy",
    from: "v2-incompatible.js.template",
    to: "v2-incompatible.js"
  }, pkgConfigTemplate({
    outDir,
    flags: options.flags
  }), flags.gitignore && gitignoreTemplate(), flags.typescript && tsconfigTemplate({
    flags: options.flags
  }), flags.typescript && tsconfigTemplateDist({
    outDir,
    flags: options.flags
  }), flags.typescript && tsconfigTemplateSettings({
    flags: options.flags
  }), flags.prettier && prettierignoreTemplate({
    outDir
  }), flags.prettier && {
    type: "copy",
    from: "prettierrc.json",
    to: ".prettierrc"
  }].map(f => f ? f : void 0).filter(f => !!f);
  const result = writeAssets(files, options);
  return result;
}
function asArray(input) {
  return typeof input === "string" ? [input] : input;
}
async function findAssetsDir() {
  let maxBackpaddle = 3;
  let currDir = __dirname;
  let assetsDir = "";
  while (!assetsDir && maxBackpaddle) {
    currDir = path__default.default.join(currDir, "..");
    const assets = path__default.default.join(currDir, "assets");
    if (await _package$1.fileExists(assets)) {
      assetsDir = assets;
    } else {
      maxBackpaddle--;
    }
  }
  if (!assetsDir) {
    throw new Error("Could not find assets directory!");
  }
  return assetsDir;
}
async function addCompileDirToGitIgnore(data, options) {
  var _ref7;
  var _a, _b;
  const gitIgnorePath = path__default.default.join(options.basePath, ".gitignore");
  const gitignore = await _package$1.readFile(gitIgnorePath, "utf8").catch(_package$1.errorToUndefined);
  if (!gitignore) {
    return false;
  }
  const output = (_ref7 = (_a = data.pkg) == null ? void 0 : _a.main) !== null && _ref7 !== void 0 ? _ref7 : (_b = data.pkg) == null ? void 0 : _b.module;
  if (!output) {
    return false;
  }
  const ignorePath = output.replace(/^[./]+/, "");
  const ignore = ignorePath.split("/")[0];
  if (!ignore) {
    return false;
  }
  const lines = gitignore.trim().split("\n");
  if (lines.includes(ignore)) {
    return false;
  }
  lines.push("", "# Compiled plugin", ignore);
  await _package$1.writeFile(gitIgnorePath, lines.join("\n") + "\n", {
    encoding: "utf8"
  });
  return true;
}
function defaultSourceJs(pkg) {
  return outdent__default.default(_templateObject13 || (_templateObject13 = _taggedTemplateLiteral(["\n  import {definePlugin} from 'sanity'\n\n  /**\n   * Usage in sanity.config.js (or .ts)\n   *\n   * ```js\n   * import {defineConfig} from 'sanity'\n   * import {myPlugin} from '", "'\n   *\n   * export default defineConfig({\n   *   // ...\n   *   plugins: [myPlugin({})],\n   * })\n   * ```\n   */\n  export const myPlugin = definePlugin((config = {}) => {\n    // eslint-disable-next-line no-console\n    console.log(`hello from ", "`)\n    return {\n      name: '", "',\n    }\n  })\n"], ["\n  import {definePlugin} from 'sanity'\n\n  /**\n   * Usage in sanity.config.js (or .ts)\n   *\n   * \\`\\`\\`js\n   * import {defineConfig} from 'sanity'\n   * import {myPlugin} from '", "'\n   *\n   * export default defineConfig({\n   *   // ...\n   *   plugins: [myPlugin({})],\n   * })\n   * \\`\\`\\`\n   */\n  export const myPlugin = definePlugin((config = {}) => {\n    // eslint-disable-next-line no-console\n    console.log(\\`hello from ", "\\`)\n    return {\n      name: '", "',\n    }\n  })\n"])), pkg.name, pkg.name, pkg.name).trimStart() + "\n";
}
function defaultSourceTs(pkg) {
  return outdent__default.default(_templateObject14 || (_templateObject14 = _taggedTemplateLiteral(["\n  import {definePlugin} from 'sanity'\n\n  interface MyPluginConfig {\n    /* nothing here yet */\n  }\n\n  /**\n   * Usage in `sanity.config.ts` (or .js)\n   *\n   * ```ts\n   * import {defineConfig} from 'sanity'\n   * import {myPlugin} from '", "'\n   *\n   * export default defineConfig({\n   *   // ...\n   *   plugins: [myPlugin()],\n   * })\n   * ```\n   */\n  export const myPlugin = definePlugin<MyPluginConfig | void>((config = {}) => {\n    // eslint-disable-next-line no-console\n    console.log('hello from ", "')\n    return {\n      name: '", "',\n    }\n  })\n"], ["\n  import {definePlugin} from 'sanity'\n\n  interface MyPluginConfig {\n    /* nothing here yet */\n  }\n\n  /**\n   * Usage in \\`sanity.config.ts\\` (or .js)\n   *\n   * \\`\\`\\`ts\n   * import {defineConfig} from 'sanity'\n   * import {myPlugin} from '", "'\n   *\n   * export default defineConfig({\n   *   // ...\n   *   plugins: [myPlugin()],\n   * })\n   * \\`\\`\\`\n   */\n  export const myPlugin = definePlugin<MyPluginConfig | void>((config = {}) => {\n    // eslint-disable-next-line no-console\n    console.log('hello from ", "')\n    return {\n      name: '", "',\n    }\n  })\n"])), pkg.name, pkg.name, pkg.name).trimStart() + "\n";
}
const initFlags = _objectSpread(_objectSpread({}, cli.sharedFlags), {}, {
  scripts: {
    type: "boolean",
    default: true
  },
  eslint: {
    type: "boolean",
    default: true
  },
  typescript: {
    type: "boolean",
    default: true
  },
  prettier: {
    type: "boolean",
    default: true
  },
  license: {
    type: "string"
  },
  editorconfig: {
    type: "boolean",
    default: true
  },
  gitignore: {
    type: "boolean",
    default: true
  },
  force: {
    type: "boolean",
    default: false
  },
  install: {
    type: "boolean",
    default: true
  },
  name: {
    type: "string"
  },
  author: {
    type: "string"
  },
  repo: {
    type: "string"
  },
  presetOnly: {
    type: "boolean",
    default: false
  },
  preset: {
    type: "string",
    isMultiple: true
  }
});
async function init(options) {
  let dependencies = {};
  let devDependencies = {};
  let peerDependencies = {};
  await inject(_objectSpread(_objectSpread({}, options), {}, {
    outDir: cli.defaultOutDir,
    requireUserConfirmation: !options.flags.force,
    dependencies,
    devDependencies,
    peerDependencies,
    validate: false
  }));
  const packageJson = await _package$1.getPackage({
    basePath: options.basePath,
    validate: false
  });
  const typescript = options.flags.typescript;
  const source = typescript ? defaultSourceTs(packageJson) : defaultSourceJs(packageJson);
  const filename = typescript ? "index.ts" : "index.js";
  const srcDir = path__default.default.resolve(options.basePath, "src");
  await _package$1.ensureDir(srcDir);
  await _package$1.writeFile(path__default.default.join(srcDir, filename), source, {
    encoding: "utf8"
  });
}
exports.init = init;
exports.initFlags = initFlags;
exports.inject = inject;
exports.presetHelpList = presetHelpList;
//# sourceMappingURL=init-7cd30f64.js.map
