'use strict';

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19, _templateObject20;
const _excluded = ["default", "force"];
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var fs = require('fs');
var path = require('path');
var util$1 = require('util');
var githubUrlToObject = require('github-url-to-object');
var validateNpmPackageName = require('validate-npm-package-name');
var _package = require('./package-f79f12a7.js');
var pAny = require('p-any');
var crypto = require('crypto');
var url = require('url');
var inquirer = require('inquirer');
var cli = require('./cli-dbe00b65.js');
var pProps = require('p-props');
var getLatestVersion = require('get-latest-version');
var outdent = require('outdent');
var findBabelConfig = require('find-babel-config');
var chalk = require('chalk');
function _interopDefaultCompat(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    default: e
  };
}
var fs__default = /*#__PURE__*/_interopDefaultCompat(fs);
var path__default = /*#__PURE__*/_interopDefaultCompat(path);
var util__default = /*#__PURE__*/_interopDefaultCompat(util$1);
var githubUrlToObject__default = /*#__PURE__*/_interopDefaultCompat(githubUrlToObject);
var validateNpmPackageName__default = /*#__PURE__*/_interopDefaultCompat(validateNpmPackageName);
var pAny__default = /*#__PURE__*/_interopDefaultCompat(pAny);
var crypto__default = /*#__PURE__*/_interopDefaultCompat(crypto);
var inquirer__default = /*#__PURE__*/_interopDefaultCompat(inquirer);
var pProps__default = /*#__PURE__*/_interopDefaultCompat(pProps);
var getLatestVersion__default = /*#__PURE__*/_interopDefaultCompat(getLatestVersion);
var outdent__default = /*#__PURE__*/_interopDefaultCompat(outdent);
var findBabelConfig__default = /*#__PURE__*/_interopDefaultCompat(findBabelConfig);
var chalk__default = /*#__PURE__*/_interopDefaultCompat(chalk);
const buildExtensions = [".js", ".jsx", ".es6", ".es", ".mjs", ".ts", ".tsx"];
async function prompt(message, options) {
  const type = options.choices ? "list" : options.type;
  const result = await inquirer__default.default.prompt([_objectSpread(_objectSpread({}, options), {}, {
    type,
    message,
    name: "single"
  })]);
  return result && result.single;
}
prompt.separator = () => new inquirer__default.default.Separator();
function promptForPackageName(_ref, defaultVal) {
  let {
    basePath
  } = _ref;
  return prompt("Plugin name (sanity-plugin-...)", {
    default: defaultVal || path__default.default.basename(basePath),
    filter: name => {
      const prefixless = name.trim().replace(/^sanity-plugin-/, "");
      return name[0] === "@" ? name : "sanity-plugin-".concat(prefixless);
    },
    validate: name => {
      const valid = validateNpmPackageName__default.default(name);
      if (valid.errors) {
        return valid.errors[0];
      }
      if (name[0] !== "@" && name.endsWith("plugin")) {
        return "Name shouldn't include \"plugin\" multiple times (".concat(name, ")");
      }
      return true;
    }
  });
}
function promptForRepoOrigin(options, defaultVal) {
  return prompt("Git repository URL", {
    default: defaultVal,
    filter: raw => {
      const url = (raw || "").trim();
      const gh = githubUrlToObject__default.default(url);
      return gh ? "git+ssh://git@github.com/".concat(gh.user, "/").concat(gh.repo, ".git") : url;
    },
    validate: url$1 => {
      if (!url$1) {
        return true;
      }
      try {
        const parsed = new url.URL(url$1);
        return parsed ? true : "Invalid URL";
      } catch (err) {
        return "Invalid URL";
      }
    }
  });
}

// This is a generated file. Do not edit.
var Space_Separator = /[\u1680\u2000-\u200A\u202F\u205F\u3000]/;
var ID_Start = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
var ID_Continue = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u09FC\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9-\u0AFF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D00-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF9\u1D00-\u1DF9\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDE00-\uDE3E\uDE47\uDE50-\uDE83\uDE86-\uDE99\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD47\uDD50-\uDD59]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/;
var unicode = {
  Space_Separator: Space_Separator,
  ID_Start: ID_Start,
  ID_Continue: ID_Continue
};
var util = {
  isSpaceSeparator(c) {
    return typeof c === 'string' && unicode.Space_Separator.test(c);
  },
  isIdStartChar(c) {
    return typeof c === 'string' && (c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c === '$' || c === '_' || unicode.ID_Start.test(c));
  },
  isIdContinueChar(c) {
    return typeof c === 'string' && (c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c >= '0' && c <= '9' || c === '$' || c === '_' || c === '\u200C' || c === '\u200D' || unicode.ID_Continue.test(c));
  },
  isDigit(c) {
    return typeof c === 'string' && /[0-9]/.test(c);
  },
  isHexDigit(c) {
    return typeof c === 'string' && /[0-9A-Fa-f]/.test(c);
  }
};
let source;
let parseState;
let stack;
let pos;
let line;
let column;
let token;
let key;
let root;
var parse = function parse(text, reviver) {
  source = String(text);
  parseState = 'start';
  stack = [];
  pos = 0;
  line = 1;
  column = 0;
  token = undefined;
  key = undefined;
  root = undefined;
  do {
    token = lex();

    // This code is unreachable.
    // if (!parseStates[parseState]) {
    //     throw invalidParseState()
    // }

    parseStates[parseState]();
  } while (token.type !== 'eof');
  if (typeof reviver === 'function') {
    return internalize({
      '': root
    }, '', reviver);
  }
  return root;
};
function internalize(holder, name, reviver) {
  const value = holder[name];
  if (value != null && typeof value === 'object') {
    if (Array.isArray(value)) {
      for (let i = 0; i < value.length; i++) {
        const key = String(i);
        const replacement = internalize(value, key, reviver);
        if (replacement === undefined) {
          delete value[key];
        } else {
          Object.defineProperty(value, key, {
            value: replacement,
            writable: true,
            enumerable: true,
            configurable: true
          });
        }
      }
    } else {
      for (const key in value) {
        const replacement = internalize(value, key, reviver);
        if (replacement === undefined) {
          delete value[key];
        } else {
          Object.defineProperty(value, key, {
            value: replacement,
            writable: true,
            enumerable: true,
            configurable: true
          });
        }
      }
    }
  }
  return reviver.call(holder, name, value);
}
let lexState;
let buffer;
let doubleQuote;
let sign;
let c;
function lex() {
  lexState = 'default';
  buffer = '';
  doubleQuote = false;
  sign = 1;
  for (;;) {
    c = peek();

    // This code is unreachable.
    // if (!lexStates[lexState]) {
    //     throw invalidLexState(lexState)
    // }

    const token = lexStates[lexState]();
    if (token) {
      return token;
    }
  }
}
function peek() {
  if (source[pos]) {
    return String.fromCodePoint(source.codePointAt(pos));
  }
}
function read() {
  const c = peek();
  if (c === '\n') {
    line++;
    column = 0;
  } else if (c) {
    column += c.length;
  } else {
    column++;
  }
  if (c) {
    pos += c.length;
  }
  return c;
}
const lexStates = {
  default() {
    switch (c) {
      case '\t':
      case '\v':
      case '\f':
      case ' ':
      case '\u00A0':
      case '\uFEFF':
      case '\n':
      case '\r':
      case '\u2028':
      case '\u2029':
        read();
        return;
      case '/':
        read();
        lexState = 'comment';
        return;
      case undefined:
        read();
        return newToken('eof');
    }
    if (util.isSpaceSeparator(c)) {
      read();
      return;
    }

    // This code is unreachable.
    // if (!lexStates[parseState]) {
    //     throw invalidLexState(parseState)
    // }

    return lexStates[parseState]();
  },
  comment() {
    switch (c) {
      case '*':
        read();
        lexState = 'multiLineComment';
        return;
      case '/':
        read();
        lexState = 'singleLineComment';
        return;
    }
    throw invalidChar(read());
  },
  multiLineComment() {
    switch (c) {
      case '*':
        read();
        lexState = 'multiLineCommentAsterisk';
        return;
      case undefined:
        throw invalidChar(read());
    }
    read();
  },
  multiLineCommentAsterisk() {
    switch (c) {
      case '*':
        read();
        return;
      case '/':
        read();
        lexState = 'default';
        return;
      case undefined:
        throw invalidChar(read());
    }
    read();
    lexState = 'multiLineComment';
  },
  singleLineComment() {
    switch (c) {
      case '\n':
      case '\r':
      case '\u2028':
      case '\u2029':
        read();
        lexState = 'default';
        return;
      case undefined:
        read();
        return newToken('eof');
    }
    read();
  },
  value() {
    switch (c) {
      case '{':
      case '[':
        return newToken('punctuator', read());
      case 'n':
        read();
        literal('ull');
        return newToken('null', null);
      case 't':
        read();
        literal('rue');
        return newToken('boolean', true);
      case 'f':
        read();
        literal('alse');
        return newToken('boolean', false);
      case '-':
      case '+':
        if (read() === '-') {
          sign = -1;
        }
        lexState = 'sign';
        return;
      case '.':
        buffer = read();
        lexState = 'decimalPointLeading';
        return;
      case '0':
        buffer = read();
        lexState = 'zero';
        return;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        buffer = read();
        lexState = 'decimalInteger';
        return;
      case 'I':
        read();
        literal('nfinity');
        return newToken('numeric', Infinity);
      case 'N':
        read();
        literal('aN');
        return newToken('numeric', NaN);
      case '"':
      case "'":
        doubleQuote = read() === '"';
        buffer = '';
        lexState = 'string';
        return;
    }
    throw invalidChar(read());
  },
  identifierNameStartEscape() {
    if (c !== 'u') {
      throw invalidChar(read());
    }
    read();
    const u = unicodeEscape();
    switch (u) {
      case '$':
      case '_':
        break;
      default:
        if (!util.isIdStartChar(u)) {
          throw invalidIdentifier();
        }
        break;
    }
    buffer += u;
    lexState = 'identifierName';
  },
  identifierName() {
    switch (c) {
      case '$':
      case '_':
      case '\u200C':
      case '\u200D':
        buffer += read();
        return;
      case '\\':
        read();
        lexState = 'identifierNameEscape';
        return;
    }
    if (util.isIdContinueChar(c)) {
      buffer += read();
      return;
    }
    return newToken('identifier', buffer);
  },
  identifierNameEscape() {
    if (c !== 'u') {
      throw invalidChar(read());
    }
    read();
    const u = unicodeEscape();
    switch (u) {
      case '$':
      case '_':
      case '\u200C':
      case '\u200D':
        break;
      default:
        if (!util.isIdContinueChar(u)) {
          throw invalidIdentifier();
        }
        break;
    }
    buffer += u;
    lexState = 'identifierName';
  },
  sign() {
    switch (c) {
      case '.':
        buffer = read();
        lexState = 'decimalPointLeading';
        return;
      case '0':
        buffer = read();
        lexState = 'zero';
        return;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        buffer = read();
        lexState = 'decimalInteger';
        return;
      case 'I':
        read();
        literal('nfinity');
        return newToken('numeric', sign * Infinity);
      case 'N':
        read();
        literal('aN');
        return newToken('numeric', NaN);
    }
    throw invalidChar(read());
  },
  zero() {
    switch (c) {
      case '.':
        buffer += read();
        lexState = 'decimalPoint';
        return;
      case 'e':
      case 'E':
        buffer += read();
        lexState = 'decimalExponent';
        return;
      case 'x':
      case 'X':
        buffer += read();
        lexState = 'hexadecimal';
        return;
    }
    return newToken('numeric', sign * 0);
  },
  decimalInteger() {
    switch (c) {
      case '.':
        buffer += read();
        lexState = 'decimalPoint';
        return;
      case 'e':
      case 'E':
        buffer += read();
        lexState = 'decimalExponent';
        return;
    }
    if (util.isDigit(c)) {
      buffer += read();
      return;
    }
    return newToken('numeric', sign * Number(buffer));
  },
  decimalPointLeading() {
    if (util.isDigit(c)) {
      buffer += read();
      lexState = 'decimalFraction';
      return;
    }
    throw invalidChar(read());
  },
  decimalPoint() {
    switch (c) {
      case 'e':
      case 'E':
        buffer += read();
        lexState = 'decimalExponent';
        return;
    }
    if (util.isDigit(c)) {
      buffer += read();
      lexState = 'decimalFraction';
      return;
    }
    return newToken('numeric', sign * Number(buffer));
  },
  decimalFraction() {
    switch (c) {
      case 'e':
      case 'E':
        buffer += read();
        lexState = 'decimalExponent';
        return;
    }
    if (util.isDigit(c)) {
      buffer += read();
      return;
    }
    return newToken('numeric', sign * Number(buffer));
  },
  decimalExponent() {
    switch (c) {
      case '+':
      case '-':
        buffer += read();
        lexState = 'decimalExponentSign';
        return;
    }
    if (util.isDigit(c)) {
      buffer += read();
      lexState = 'decimalExponentInteger';
      return;
    }
    throw invalidChar(read());
  },
  decimalExponentSign() {
    if (util.isDigit(c)) {
      buffer += read();
      lexState = 'decimalExponentInteger';
      return;
    }
    throw invalidChar(read());
  },
  decimalExponentInteger() {
    if (util.isDigit(c)) {
      buffer += read();
      return;
    }
    return newToken('numeric', sign * Number(buffer));
  },
  hexadecimal() {
    if (util.isHexDigit(c)) {
      buffer += read();
      lexState = 'hexadecimalInteger';
      return;
    }
    throw invalidChar(read());
  },
  hexadecimalInteger() {
    if (util.isHexDigit(c)) {
      buffer += read();
      return;
    }
    return newToken('numeric', sign * Number(buffer));
  },
  string() {
    switch (c) {
      case '\\':
        read();
        buffer += escape();
        return;
      case '"':
        if (doubleQuote) {
          read();
          return newToken('string', buffer);
        }
        buffer += read();
        return;
      case "'":
        if (!doubleQuote) {
          read();
          return newToken('string', buffer);
        }
        buffer += read();
        return;
      case '\n':
      case '\r':
        throw invalidChar(read());
      case '\u2028':
      case '\u2029':
        separatorChar(c);
        break;
      case undefined:
        throw invalidChar(read());
    }
    buffer += read();
  },
  start() {
    switch (c) {
      case '{':
      case '[':
        return newToken('punctuator', read());

      // This code is unreachable since the default lexState handles eof.
      // case undefined:
      //     return newToken('eof')
    }

    lexState = 'value';
  },
  beforePropertyName() {
    switch (c) {
      case '$':
      case '_':
        buffer = read();
        lexState = 'identifierName';
        return;
      case '\\':
        read();
        lexState = 'identifierNameStartEscape';
        return;
      case '}':
        return newToken('punctuator', read());
      case '"':
      case "'":
        doubleQuote = read() === '"';
        lexState = 'string';
        return;
    }
    if (util.isIdStartChar(c)) {
      buffer += read();
      lexState = 'identifierName';
      return;
    }
    throw invalidChar(read());
  },
  afterPropertyName() {
    if (c === ':') {
      return newToken('punctuator', read());
    }
    throw invalidChar(read());
  },
  beforePropertyValue() {
    lexState = 'value';
  },
  afterPropertyValue() {
    switch (c) {
      case ',':
      case '}':
        return newToken('punctuator', read());
    }
    throw invalidChar(read());
  },
  beforeArrayValue() {
    if (c === ']') {
      return newToken('punctuator', read());
    }
    lexState = 'value';
  },
  afterArrayValue() {
    switch (c) {
      case ',':
      case ']':
        return newToken('punctuator', read());
    }
    throw invalidChar(read());
  },
  end() {
    // This code is unreachable since it's handled by the default lexState.
    // if (c === undefined) {
    //     read()
    //     return newToken('eof')
    // }

    throw invalidChar(read());
  }
};
function newToken(type, value) {
  return {
    type,
    value,
    line,
    column
  };
}
function literal(s) {
  for (const c of s) {
    const p = peek();
    if (p !== c) {
      throw invalidChar(read());
    }
    read();
  }
}
function escape() {
  const c = peek();
  switch (c) {
    case 'b':
      read();
      return '\b';
    case 'f':
      read();
      return '\f';
    case 'n':
      read();
      return '\n';
    case 'r':
      read();
      return '\r';
    case 't':
      read();
      return '\t';
    case 'v':
      read();
      return '\v';
    case '0':
      read();
      if (util.isDigit(peek())) {
        throw invalidChar(read());
      }
      return '\0';
    case 'x':
      read();
      return hexEscape();
    case 'u':
      read();
      return unicodeEscape();
    case '\n':
    case '\u2028':
    case '\u2029':
      read();
      return '';
    case '\r':
      read();
      if (peek() === '\n') {
        read();
      }
      return '';
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      throw invalidChar(read());
    case undefined:
      throw invalidChar(read());
  }
  return read();
}
function hexEscape() {
  let buffer = '';
  let c = peek();
  if (!util.isHexDigit(c)) {
    throw invalidChar(read());
  }
  buffer += read();
  c = peek();
  if (!util.isHexDigit(c)) {
    throw invalidChar(read());
  }
  buffer += read();
  return String.fromCodePoint(parseInt(buffer, 16));
}
function unicodeEscape() {
  let buffer = '';
  let count = 4;
  while (count-- > 0) {
    const c = peek();
    if (!util.isHexDigit(c)) {
      throw invalidChar(read());
    }
    buffer += read();
  }
  return String.fromCodePoint(parseInt(buffer, 16));
}
const parseStates = {
  start() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    push();
  },
  beforePropertyName() {
    switch (token.type) {
      case 'identifier':
      case 'string':
        key = token.value;
        parseState = 'afterPropertyName';
        return;
      case 'punctuator':
        // This code is unreachable since it's handled by the lexState.
        // if (token.value !== '}') {
        //     throw invalidToken()
        // }

        pop();
        return;
      case 'eof':
        throw invalidEOF();
    }

    // This code is unreachable since it's handled by the lexState.
    // throw invalidToken()
  },

  afterPropertyName() {
    // This code is unreachable since it's handled by the lexState.
    // if (token.type !== 'punctuator' || token.value !== ':') {
    //     throw invalidToken()
    // }

    if (token.type === 'eof') {
      throw invalidEOF();
    }
    parseState = 'beforePropertyValue';
  },
  beforePropertyValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    push();
  },
  beforeArrayValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    if (token.type === 'punctuator' && token.value === ']') {
      pop();
      return;
    }
    push();
  },
  afterPropertyValue() {
    // This code is unreachable since it's handled by the lexState.
    // if (token.type !== 'punctuator') {
    //     throw invalidToken()
    // }

    if (token.type === 'eof') {
      throw invalidEOF();
    }
    switch (token.value) {
      case ',':
        parseState = 'beforePropertyName';
        return;
      case '}':
        pop();
    }

    // This code is unreachable since it's handled by the lexState.
    // throw invalidToken()
  },

  afterArrayValue() {
    // This code is unreachable since it's handled by the lexState.
    // if (token.type !== 'punctuator') {
    //     throw invalidToken()
    // }

    if (token.type === 'eof') {
      throw invalidEOF();
    }
    switch (token.value) {
      case ',':
        parseState = 'beforeArrayValue';
        return;
      case ']':
        pop();
    }

    // This code is unreachable since it's handled by the lexState.
    // throw invalidToken()
  },

  end() {
    // This code is unreachable since it's handled by the lexState.
    // if (token.type !== 'eof') {
    //     throw invalidToken()
    // }
  }
};
function push() {
  let value;
  switch (token.type) {
    case 'punctuator':
      switch (token.value) {
        case '{':
          value = {};
          break;
        case '[':
          value = [];
          break;
      }
      break;
    case 'null':
    case 'boolean':
    case 'numeric':
    case 'string':
      value = token.value;
      break;

    // This code is unreachable.
    // default:
    //     throw invalidToken()
  }

  if (root === undefined) {
    root = value;
  } else {
    const parent = stack[stack.length - 1];
    if (Array.isArray(parent)) {
      parent.push(value);
    } else {
      Object.defineProperty(parent, key, {
        value,
        writable: true,
        enumerable: true,
        configurable: true
      });
    }
  }
  if (value !== null && typeof value === 'object') {
    stack.push(value);
    if (Array.isArray(value)) {
      parseState = 'beforeArrayValue';
    } else {
      parseState = 'beforePropertyName';
    }
  } else {
    const current = stack[stack.length - 1];
    if (current == null) {
      parseState = 'end';
    } else if (Array.isArray(current)) {
      parseState = 'afterArrayValue';
    } else {
      parseState = 'afterPropertyValue';
    }
  }
}
function pop() {
  stack.pop();
  const current = stack[stack.length - 1];
  if (current == null) {
    parseState = 'end';
  } else if (Array.isArray(current)) {
    parseState = 'afterArrayValue';
  } else {
    parseState = 'afterPropertyValue';
  }
}

// This code is unreachable.
// function invalidParseState () {
//     return new Error(`JSON5: invalid parse state '${parseState}'`)
// }

// This code is unreachable.
// function invalidLexState (state) {
//     return new Error(`JSON5: invalid lex state '${state}'`)
// }

function invalidChar(c) {
  if (c === undefined) {
    return syntaxError("JSON5: invalid end of input at ".concat(line, ":").concat(column));
  }
  return syntaxError("JSON5: invalid character '".concat(formatChar(c), "' at ").concat(line, ":").concat(column));
}
function invalidEOF() {
  return syntaxError("JSON5: invalid end of input at ".concat(line, ":").concat(column));
}

// This code is unreachable.
// function invalidToken () {
//     if (token.type === 'eof') {
//         return syntaxError(`JSON5: invalid end of input at ${line}:${column}`)
//     }

//     const c = String.fromCodePoint(token.value.codePointAt(0))
//     return syntaxError(`JSON5: invalid character '${formatChar(c)}' at ${line}:${column}`)
// }

function invalidIdentifier() {
  column -= 5;
  return syntaxError("JSON5: invalid identifier character at ".concat(line, ":").concat(column));
}
function separatorChar(c) {
  console.warn("JSON5: '".concat(formatChar(c), "' in strings is not valid ECMAScript; consider escaping"));
}
function formatChar(c) {
  const replacements = {
    "'": "\\'",
    '"': '\\"',
    '\\': '\\\\',
    '\b': '\\b',
    '\f': '\\f',
    '\n': '\\n',
    '\r': '\\r',
    '\t': '\\t',
    '\v': '\\v',
    '\0': '\\0',
    '\u2028': '\\u2028',
    '\u2029': '\\u2029'
  };
  if (replacements[c]) {
    return replacements[c];
  }
  if (c < ' ') {
    const hexString = c.charCodeAt(0).toString(16);
    return '\\x' + ('00' + hexString).substring(hexString.length);
  }
  return c;
}
function syntaxError(message) {
  const err = new SyntaxError(message);
  err.lineNumber = line;
  err.columnNumber = column;
  return err;
}
var stringify = function stringify(value, replacer, space) {
  const stack = [];
  let indent = '';
  let propertyList;
  let replacerFunc;
  let gap = '';
  let quote;
  if (replacer != null && typeof replacer === 'object' && !Array.isArray(replacer)) {
    space = replacer.space;
    quote = replacer.quote;
    replacer = replacer.replacer;
  }
  if (typeof replacer === 'function') {
    replacerFunc = replacer;
  } else if (Array.isArray(replacer)) {
    propertyList = [];
    for (const v of replacer) {
      let item;
      if (typeof v === 'string') {
        item = v;
      } else if (typeof v === 'number' || v instanceof String || v instanceof Number) {
        item = String(v);
      }
      if (item !== undefined && propertyList.indexOf(item) < 0) {
        propertyList.push(item);
      }
    }
  }
  if (space instanceof Number) {
    space = Number(space);
  } else if (space instanceof String) {
    space = String(space);
  }
  if (typeof space === 'number') {
    if (space > 0) {
      space = Math.min(10, Math.floor(space));
      gap = '          '.substr(0, space);
    }
  } else if (typeof space === 'string') {
    gap = space.substr(0, 10);
  }
  return serializeProperty('', {
    '': value
  });
  function serializeProperty(key, holder) {
    let value = holder[key];
    if (value != null) {
      if (typeof value.toJSON5 === 'function') {
        value = value.toJSON5(key);
      } else if (typeof value.toJSON === 'function') {
        value = value.toJSON(key);
      }
    }
    if (replacerFunc) {
      value = replacerFunc.call(holder, key, value);
    }
    if (value instanceof Number) {
      value = Number(value);
    } else if (value instanceof String) {
      value = String(value);
    } else if (value instanceof Boolean) {
      value = value.valueOf();
    }
    switch (value) {
      case null:
        return 'null';
      case true:
        return 'true';
      case false:
        return 'false';
    }
    if (typeof value === 'string') {
      return quoteString(value);
    }
    if (typeof value === 'number') {
      return String(value);
    }
    if (typeof value === 'object') {
      return Array.isArray(value) ? serializeArray(value) : serializeObject(value);
    }
    return undefined;
  }
  function quoteString(value) {
    const quotes = {
      "'": 0.1,
      '"': 0.2
    };
    const replacements = {
      "'": "\\'",
      '"': '\\"',
      '\\': '\\\\',
      '\b': '\\b',
      '\f': '\\f',
      '\n': '\\n',
      '\r': '\\r',
      '\t': '\\t',
      '\v': '\\v',
      '\0': '\\0',
      '\u2028': '\\u2028',
      '\u2029': '\\u2029'
    };
    let product = '';
    for (let i = 0; i < value.length; i++) {
      const c = value[i];
      switch (c) {
        case "'":
        case '"':
          quotes[c]++;
          product += c;
          continue;
        case '\0':
          if (util.isDigit(value[i + 1])) {
            product += '\\x00';
            continue;
          }
      }
      if (replacements[c]) {
        product += replacements[c];
        continue;
      }
      if (c < ' ') {
        let hexString = c.charCodeAt(0).toString(16);
        product += '\\x' + ('00' + hexString).substring(hexString.length);
        continue;
      }
      product += c;
    }
    const quoteChar = quote || Object.keys(quotes).reduce((a, b) => quotes[a] < quotes[b] ? a : b);
    product = product.replace(new RegExp(quoteChar, 'g'), replacements[quoteChar]);
    return quoteChar + product + quoteChar;
  }
  function serializeObject(value) {
    if (stack.indexOf(value) >= 0) {
      throw TypeError('Converting circular structure to JSON5');
    }
    stack.push(value);
    let stepback = indent;
    indent = indent + gap;
    let keys = propertyList || Object.keys(value);
    let partial = [];
    for (const key of keys) {
      const propertyString = serializeProperty(key, value);
      if (propertyString !== undefined) {
        let member = serializeKey(key) + ':';
        if (gap !== '') {
          member += ' ';
        }
        member += propertyString;
        partial.push(member);
      }
    }
    let final;
    if (partial.length === 0) {
      final = '{}';
    } else {
      let properties;
      if (gap === '') {
        properties = partial.join(',');
        final = '{' + properties + '}';
      } else {
        let separator = ',\n' + indent;
        properties = partial.join(separator);
        final = '{\n' + indent + properties + ',\n' + stepback + '}';
      }
    }
    stack.pop();
    indent = stepback;
    return final;
  }
  function serializeKey(key) {
    if (key.length === 0) {
      return quoteString(key);
    }
    const firstChar = String.fromCodePoint(key.codePointAt(0));
    if (!util.isIdStartChar(firstChar)) {
      return quoteString(key);
    }
    for (let i = firstChar.length; i < key.length; i++) {
      if (!util.isIdContinueChar(String.fromCodePoint(key.codePointAt(i)))) {
        return quoteString(key);
      }
    }
    return key;
  }
  function serializeArray(value) {
    if (stack.indexOf(value) >= 0) {
      throw TypeError('Converting circular structure to JSON5');
    }
    stack.push(value);
    let stepback = indent;
    indent = indent + gap;
    let partial = [];
    for (let i = 0; i < value.length; i++) {
      const propertyString = serializeProperty(String(i), value);
      partial.push(propertyString !== undefined ? propertyString : 'null');
    }
    let final;
    if (partial.length === 0) {
      final = '[]';
    } else {
      if (gap === '') {
        let properties = partial.join(',');
        final = '[' + properties + ']';
      } else {
        let separator = ',\n' + indent;
        let properties = partial.join(separator);
        final = '[\n' + indent + properties + ',\n' + stepback + ']';
      }
    }
    stack.pop();
    indent = stepback;
    return final;
  }
};
const JSON5 = {
  parse,
  stringify
};
var lib = JSON5;
const stat$1 = util__default.default.promisify(fs__default.default.stat);
const mkdir = util__default.default.promisify(fs__default.default.mkdir);
const readdir = util__default.default.promisify(fs__default.default.readdir);
const copyFile = util__default.default.promisify(fs__default.default.copyFile);
const readFile$2 = util__default.default.promisify(fs__default.default.readFile);
const writeFile = util__default.default.promisify(fs__default.default.writeFile);
function hasSourceEquivalent(compiledFile, paths) {
  if (!paths.source) {
    return fileExists(path__default.default.isAbsolute(compiledFile) ? compiledFile : path__default.default.resolve(paths.basePath, compiledFile));
  }
  const baseDir = path__default.default.dirname(compiledFile.replace(paths.compiled, paths.source));
  const baseName = path__default.default.basename(compiledFile, path__default.default.extname(compiledFile));
  const pathStub = path__default.default.join(baseDir, baseName);
  return buildCandidateExists(pathStub);
}
async function hasSourceFile(filePath, paths) {
  if (!(paths == null ? void 0 : paths.source)) {
    var _ref2;
    return fileExists(path__default.default.isAbsolute(filePath) ? filePath : path__default.default.resolve((_ref2 = paths == null ? void 0 : paths.basePath) !== null && _ref2 !== void 0 ? _ref2 : "", filePath));
  }
  const pathStub = path__default.default.isAbsolute(filePath) ? filePath : path__default.default.resolve(paths.source, filePath);
  if (await fileExists(pathStub)) {
    return true;
  }
  return buildCandidateExists(pathStub);
}
function hasCompiledFile(filePath, paths) {
  if (!(paths == null ? void 0 : paths.compiled)) {
    var _ref3;
    return fileExists(path__default.default.isAbsolute(filePath) ? filePath : path__default.default.resolve((_ref3 = paths == null ? void 0 : paths.basePath) !== null && _ref3 !== void 0 ? _ref3 : "", filePath));
  }
  const absPath = path__default.default.isAbsolute(filePath) ? filePath : path__default.default.resolve(paths.compiled, filePath);
  const fileExt = path__default.default.extname(absPath);
  const withExt = fileExt === "" ? "".concat(absPath, ".js") : absPath;
  return fileExists(withExt);
}
function buildCandidateExists(pathStub) {
  const candidates = buildExtensions.map(extCandidate => "".concat(pathStub).concat(extCandidate));
  return pAny__default.default(candidates.map(candidate => stat$1(candidate))).then(() => true).catch(() => false);
}
function fileExists(filePath) {
  return stat$1(filePath).then(() => true).catch(() => false);
}
async function readJsonFile(filePath) {
  const content = await readFile$2(filePath, "utf8");
  return JSON.parse(content);
}
function writeJsonFile(filePath, content) {
  const data = JSON.stringify(content, null, 2) + "\n";
  return writeFile(filePath, data, {
    encoding: "utf8"
  });
}
async function writeFileWithOverwritePrompt(filePath, content, options) {
  const {
      default: defaultVal,
      force = false
    } = options,
    writeOptions = _objectWithoutProperties(options, _excluded);
  const withinCwd = filePath.startsWith(process.cwd());
  const printablePath = withinCwd ? path__default.default.relative(process.cwd(), filePath) : filePath;
  if (await fileEqualsData(filePath, content)) {
    return false;
  }
  if (!force && (await fileExists(filePath)) && !(await prompt("File \"".concat(printablePath, "\" already exists. Overwrite?"), {
    type: "confirm",
    default: defaultVal
  }))) {
    return false;
  }
  await writeFile(filePath, content, writeOptions);
  return true;
}
async function copyFileWithOverwritePrompt(from, to, flags) {
  const withinCwd = to.startsWith(process.cwd());
  const printablePath = withinCwd ? path__default.default.relative(process.cwd(), to) : to;
  if (await filesAreEqual(from, to)) {
    return false;
  }
  await ensureDirectoryExists(to);
  if (!flags.force && (await fileExists(to)) && !(await prompt("File \"".concat(printablePath, "\" already exists. Overwrite?"), {
    type: "confirm",
    default: false
  }))) {
    return false;
  }
  await copyFile(from, to);
  return true;
}
async function ensureDirectoryExists(filePath) {
  const dirname = path__default.default.dirname(filePath);
  if (await fileExists(dirname)) {
    return true;
  }
  await ensureDirectoryExists(dirname);
  await mkdir(dirname);
}
async function fileEqualsData(filePath, content) {
  const contentHash = crypto__default.default.createHash("sha1").update(content).digest("hex");
  const remoteHash = await getFileHash(filePath);
  return contentHash === remoteHash;
}
async function filesAreEqual(file1, file2) {
  const [hash1, hash2] = await Promise.all([getFileHash(file1, false), getFileHash(file2)]);
  return hash1 === hash2;
}
function getFileHash(filePath) {
  let allowMissing = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  return new Promise((resolve, reject) => {
    const hash = crypto__default.default.createHash("sha1");
    const stream = fs__default.default.createReadStream(filePath);
    stream.on("error", err => {
      if (err.code === "ENOENT" && allowMissing) {
        resolve(null);
      } else {
        reject(err);
      }
    });
    stream.on("end", () => resolve(hash.digest("hex")));
    stream.on("data", chunk => hash.update(chunk));
  });
}
async function ensureDir(dirPath) {
  try {
    await mkdir(dirPath);
  } catch (err) {
    if (err.code !== "EEXIST") {
      throw err;
    }
  }
}
async function isEmptyish(dirPath) {
  const ignoredFiles = [".git", ".gitignore", "license", "readme.md"];
  const allFiles = await readdir(dirPath).catch(() => []);
  const files = allFiles.filter(file => !ignoredFiles.includes(file.toLowerCase()));
  return files.length === 0;
}
async function readFileContent(_ref4) {
  let {
    filename,
    basePath
  } = _ref4;
  const filepath = path__default.default.normalize(path__default.default.join(basePath, filename));
  try {
    return await readFile$2(filepath, "utf8");
  } catch (err) {
    if (err.code === "ENOENT") {
      cli.log.debug("No ".concat(filename, " file found."));
      return void 0;
    }
    throw new Error("Failed to read \"".concat(filepath, "\": ").concat(err.message));
  }
}
async function readJson5File(_ref5) {
  let {
    filename,
    basePath
  } = _ref5;
  const content = await readFileContent({
    filename,
    basePath
  });
  if (!content) {
    return void 0;
  }
  return parseJson5(content, filename);
}
function parseJson5(content, errorKey) {
  try {
    return lib.parse(content);
  } catch (err) {
    throw new Error("Error parsing \"".concat(errorKey, "\": ").concat(err.message));
  }
}
function errorToUndefined(err) {
  if (err instanceof TypeError) {
    throw err;
  }
  return void 0;
}
const stat = util__default.default.promisify(fs__default.default.stat);
const readFile$1 = util__default.default.promisify(fs__default.default.readFile);
const allowedPartProps = ["name", "implements", "path", "description"];
const disallowedPluginProps = ["api", "project", "plugins", "env"];
async function getPaths(options) {
  const {
    basePath
  } = options;
  const manifest = await readManifest(options);
  if (!manifest.paths) {
    return null;
  }
  return absolutifyPaths(manifest.paths, basePath);
}
function absolutifyPaths(paths, basePath) {
  const getPath = relative => relative ? path__default.default.resolve(path__default.default.join(basePath, relative)) : void 0;
  return paths ? {
    basePath,
    compiled: getPath(paths.compiled),
    source: getPath(paths.source)
  } : {
    basePath
  };
}
async function readManifest(options) {
  const {
    basePath,
    validate = true
  } = options;
  const manifestPath = path__default.default.normalize(path__default.default.join(basePath, "sanity.json"));
  let content;
  try {
    content = await readFile$1(manifestPath, "utf8");
  } catch (err) {
    if (err.code === "ENOENT") {
      throw new Error("No sanity.json found. sanity.json is required for plugins to function. Use `".concat(_package.pkg.binname, " init` for a new plugin, or create an empty `sanity.json` with an empty object (`{}`) for existing ones."));
    }
    throw new Error("Failed to read \"".concat(manifestPath, "\": ").concat(err.message));
  }
  let parsed;
  try {
    parsed = JSON.parse(content);
  } catch (err) {
    throw new Error("Error parsing \"".concat(manifestPath, "\": ").concat(err.message));
  }
  if (validate) {
    await validateManifest(parsed, options);
  }
  return parsed;
}
async function validateManifest(manifest, opts) {
  const options = _objectSpread({
    isPlugin: true
  }, opts);
  if (!isObject$1(manifest)) {
    throw new Error("Invalid sanity.json: Root must be an object");
  }
  if (options.isPlugin) {
    await validatePluginManifest(manifest, options);
  } else {
    await validateProjectManifest(manifest);
  }
  if ("root" in manifest && typeof manifest.root !== "boolean") {
    throw new Error("Invalid sanity.json: \"root\" property must be a boolean if declared");
  }
  await validateParts(manifest, _objectSpread(_objectSpread({}, options), {}, {
    paths: absolutifyPaths(manifest.paths, options.basePath)
  }));
}
function validateProjectManifest(manifest) {
  if ("paths" in manifest) {
    throw new Error("Invalid sanity.json: \"paths\" property has no meaning in a project manifest");
  }
}
async function validatePluginManifest(manifest, options) {
  const disallowed = Object.keys(manifest).filter(key => disallowedPluginProps.includes(key)).map(key => "\"".concat(key, "\""));
  if (disallowed.length > 0) {
    const plural = disallowed.length > 1 ? "s" : "";
    const joined = disallowed.join(", ");
    throw new Error("Invalid sanity.json: Key".concat(plural, " ").concat(joined, " ").concat(plural ? "are" : "is", " not allowed in a plugin manifest"));
  }
  if (manifest.root) {
    throw new Error("Invalid sanity.json: \"root\" cannot be truthy in a plugin manifest");
  }
  await validatePaths$1(manifest, options);
}
async function validatePaths$1(manifest, options) {
  if (!("paths" in manifest)) {
    return;
  }
  if (!isObject$1(manifest.paths)) {
    throw new Error("Invalid sanity.json: \"paths\" must be an object if declared");
  }
  if (typeof manifest.paths.compiled !== "string") {
    throw new Error("Invalid sanity.json: \"paths\" must have a (string) \"compiled\" property if declared");
  }
  if (typeof manifest.paths.source !== "string") {
    throw new Error("Invalid sanity.json: \"paths\" must have a (string) \"source\" property if declared");
  }
  const sourcePath = path__default.default.resolve(options.basePath, manifest.paths.source);
  let srcStats;
  try {
    srcStats = await stat(sourcePath);
  } catch (err) {
    if (err.code === "ENOENT") {
      throw new Error("sanity.json references \"source\" path which does not exist: \"".concat(sourcePath, "\""));
    }
  }
  if (!(srcStats == null ? void 0 : srcStats.isDirectory())) {
    throw new Error("sanity.json references \"source\" path which is not a directory: \"".concat(sourcePath, "\""));
  }
}
async function validateParts(manifest, options) {
  if (!("parts" in manifest)) {
    return;
  }
  if (!Array.isArray(manifest.parts)) {
    throw new Error("Invalid sanity.json: \"parts\" must be an array if declared");
  }
  let i = 0;
  for (const part of manifest.parts) {
    await validatePart(part, i, options);
    i++;
  }
}
async function validatePart(part, index, options) {
  if (!isObject$1(part)) {
    throw new Error("Invalid sanity.json: \"parts[".concat(index, "]\" must be an object"));
  }
  validateAllowedPartKeys(part, index);
  validatePartStringValues(part, index);
  validatePartNames(part, index, options);
  await validatePartFiles(part, index, options);
}
async function validatePartFiles(part, index, options) {
  const {
    verifyCompiledParts,
    verifySourceParts,
    paths
  } = options;
  if (!(part == null ? void 0 : part.path)) {
    return;
  }
  const ext = path__default.default.extname(part.path);
  if ((paths == null ? void 0 : paths.source) && ext && ext !== ".js" && buildExtensions.includes(ext)) {
    throw new Error("Invalid sanity.json: Part path has extension which is not applicable after compiling. ".concat(ext, " becomes .js after compiling. Specify filename without extension (").concat(path__default.default.basename(part.path), ") (parts[").concat(index, "])"));
  }
  if (!verifySourceParts && !verifyCompiledParts) {
    return;
  }
  const [srcExists, outDirExists] = await Promise.all([hasSourceFile(part.path, paths), verifyCompiledParts && hasCompiledFile(part.path, paths)]);
  if (!srcExists) {
    throw new Error("Invalid sanity.json: Part path references file that does not exist in source directory (".concat((paths == null ? void 0 : paths.source) || (paths == null ? void 0 : paths.basePath), ") (parts[").concat(index, "])"));
  }
  if (verifyCompiledParts && !outDirExists) {
    throw new Error("Invalid sanity.json: Part path references file (\"".concat(part.path, "\") that does not exist in compiled directory (").concat(paths == null ? void 0 : paths.compiled, ") (parts[").concat(index, "])"));
  }
}
function validatePartNames(part, index, options) {
  var _a, _b;
  const pluginName = options.pluginName ? options.pluginName.replace(/^sanity-plugin-/, "") : "";
  if (!(part == null ? void 0 : part.name) || !((_a = part == null ? void 0 : part.name) == null ? void 0 : _a.startsWith("part:".concat(pluginName, "/")))) {
    throw new Error("Invalid sanity.json: \"name\" must be prefixed with \"part:".concat(pluginName, "/\" - got \"").concat(part == null ? void 0 : part.name, "\" (parts[").concat(index, "])"));
  }
  if (!((_b = part == null ? void 0 : part.implements) == null ? void 0 : _b.startsWith("part:"))) {
    throw new Error("Invalid sanity.json: \"implements\" must be prefixed with \"part:\" - got \"".concat(part == null ? void 0 : part.implements, "\" (parts[").concat(index, "])"));
  }
}
function validateAllowedPartKeys(part, index) {
  const disallowed = Object.keys(part).filter(key => !allowedPartProps.includes(key)).map(key => "\"".concat(key, "\""));
  if (disallowed.length > 0) {
    const plural = disallowed.length > 1 ? "s" : "";
    const joined = disallowed.join(", ");
    throw new Error("Invalid sanity.json: Key".concat(plural, " ").concat(joined, " ").concat(plural ? "are" : "is", " not allowed in a part declaration (parts[").concat(index, "])"));
  }
}
function validatePartStringValues(part, index) {
  const nonStrings = Object.keys(part).filter(key => typeof part[key] !== "string").map(key => "\"".concat(key, "\""));
  if (nonStrings.length > 0) {
    const plural = nonStrings.length > 1 ? "s" : "";
    const joined = nonStrings.join(", ");
    throw new Error("Invalid sanity.json: Key".concat(plural, " ").concat(joined, " should be of type string (parts[").concat(index, "])"));
  }
}
function isObject$1(obj) {
  return !Array.isArray(obj) && obj !== null && typeof obj === "object";
}
async function hasSanityJson(basePath) {
  const file = await readJsonFile(path__default.default.join(basePath, "sanity.json")).catch(errorToUndefined);
  return {
    exists: Boolean(file),
    isRoot: Boolean(file && file.root)
  };
}
async function findStudioV3Config(basePath) {
  const jsFile = "sanity.config.js";
  const jsExists = await fileExists(path__default.default.join(basePath, jsFile));
  if (jsExists) {
    return {
      v3ConfigFile: jsFile
    };
  }
  const tsFile = "sanity.config.ts";
  const tsExists = await fileExists(path__default.default.join(basePath, tsFile));
  return {
    v3ConfigFile: tsExists ? tsFile : void 0
  };
}
const lockedDependencies = {};
function resolveLatestVersions(packages) {
  const versions = {};
  for (const pkgName of packages) {
    versions[pkgName] = pkgName in lockedDependencies ? lockedDependencies[pkgName] : "latest";
  }
  return pProps__default.default(versions, async (range, pkgName) => {
    const version = await getLatestVersion__default.default(pkgName, {
      range
    });
    if (!version) {
      throw new Error("Found no version for ".concat(pkgName));
    }
    return rangeify(version);
  }, {
    concurrency: 8
  });
}
function rangeify(version) {
  return "^".concat(version);
}
const mergedPackages = ["@sanity/base", "@sanity/core", "@sanity/types", "@sanity/data-aspects", "@sanity/default-layout", "@sanity/default-login", "@sanity/desk-tool", "@sanity/field", "@sanity/form-builder", "@sanity/initial-value-templates", "@sanity/language-filter", "@sanity/production-preview", "@sanity/react-hooks", "@sanity/resolver", "@sanity/state-router", "@sanity/structure", "@sanity/studio-hints"].sort();
const deprecatedDevDeps = ["tsdx", "sanipack", "parcel", "@parcel/packager-ts", "@parcel/transformer-typescript-types"];
const expectedScripts = {
  build: "run-s clean && plugin-kit verify-package --silent && pkg-utils build --strict && pkg-utils --strict",
  watch: "pkg-utils watch --strict",
  "link-watch": "plugin-kit link-watch",
  prepublishOnly: "run-s build"
};
const expectedModulesFields = ["source", "exports", "main", "module", "files"];
function validateNodeEngine(packageJson) {
  var _a, _b, _c;
  const nodeVersionRange = ">=14";
  if (!((_b = (_a = packageJson.engines) == null ? void 0 : _a.node) == null ? void 0 : _b.startsWith(nodeVersionRange))) {
    return [outdent__default.default(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n        Expected package.json to contain engines.node: \">=14\" to ensure Studio compatible builds,\n        but it was: ", "\n\n        Please add the following to package.json:\n\n        \"engines\": {\n          \"node\": \"", "\"\n        }"])), (_c = packageJson.engines) == null ? void 0 : _c.node, nodeVersionRange).trimStart()];
  }
}
function validateModule(packageJson, options) {
  const {
    outDir
  } = options;
  const errors = [];
  const missingFields = expectedModulesFields.filter(field => !packageJson[field]);
  if (missingFields.length) {
    errors.push(outdent__default.default(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n        Expected source, exports, main, module and files entries in package.json, but ", " where missing.\n\n        Example:\n\n        Given a plugin with entry-point in src/index.ts, using default @sanity/pkg-utils build command,\n        package.json should contain the following entries to ensure that commonjs and esm outputs are built into ", ":\n\n        \"source\": \"./src/index.ts\",\n        \"exports\": {\n          \".\": {\n            \"types\": \"./", "/index.d.ts\",\n            \"source\": \"./src/index.ts\",\n            \"import\": \"./", "/index.esm.js\",\n            \"require\": \"./", "/index.js\",\n            \"default\": \"./", "/index.js\"\n          }\n        },\n        \"main\": \"./", "/index.js\",\n        \"module\": \"./", "/index.esm.js\",\n        \"types\": \"./", "/index.d.ts\",\n        \"files\": [\n          \"", "\",\n          \"src\"\n        ],\n\n        Refer to @sanity/pkg-utils for more: https://github.com/sanity-io/pkg-utils#sanitypkg-utils\n  "])), missingFields.join(", "), outDir, outDir, outDir, outDir, outDir, outDir, outDir, outDir, outDir).trimStart());
  }
  if (packageJson.typings) {
    errors.push(outdent__default.default(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["Found typings field in package.json. Use types instead."]))));
  }
  return errors;
}
function validateScripts(packageJson) {
  const errors = [];
  const divergentScripts = Object.entries(expectedScripts).filter(_ref6 => {
    let [key, expectedCommand] = _ref6;
    var _a;
    const command = (_a = packageJson.scripts) == null ? void 0 : _a[key];
    return !command || !command.includes(expectedCommand);
  });
  if (divergentScripts.length) {
    errors.push(outdent__default.default(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n      The following script commands did not contain expected defaults: ", "\n\n      This checks for that the commands-strings includes these terms.\n\n      Please add the following to your package.json \"scripts\":\n\n      ", "\n  "])), divergentScripts.map(_ref7 => {
      let [key] = _ref7;
      return key;
    }).join(", "), divergentScripts.map(_ref8 => {
      let [key, value] = _ref8;
      return "\"".concat(key, "\": \"").concat(value, "\"");
    }).join(",\n")).trimStart());
  }
  return errors;
}
async function validateTsConfig(ts, options) {
  const {
    basePath,
    outDir,
    tsconfig
  } = options;
  const errors = [];
  const expectedCompilerOptions = {
    moduleResolution: "node",
    target: "esnext",
    module: "esnext",
    emitDeclarationOnly: true,
    esModuleInterop: true,
    skipLibCheck: true,
    isolatedModules: true,
    downlevelIteration: true,
    declaration: true,
    allowSyntheticDefaultImports: true,
    rootDir: ".",
    outDir
  };
  const wrongEntries = Object.entries(expectedCompilerOptions).filter(_ref9 => {
    let [key, value] = _ref9;
    let option = ts.options[key];
    if (key === "rootDir" && typeof option === "string") {
      option = path__default.default.relative(basePath, option) || ".";
    }
    if (key === "outDir" && typeof option === "string") {
      option = path__default.default.relative(basePath, option) || ".";
    }
    if (key === "moduleResolution" && option === 2) {
      option = "node";
    }
    if (key === "target" && option === 99) {
      option = "esnext";
    }
    if (key === "module" && option === 99) {
      option = "esnext";
    }
    return typeof value === "string" && typeof option === "string" ? value.toLowerCase() !== (option == null ? void 0 : option.toLowerCase()) : value !== option;
  });
  if (wrongEntries.length) {
    const expectedOutput = wrongEntries.map(_ref10 => {
      let [key, value] = _ref10;
      return "\"".concat(key, "\": ").concat(typeof value === "string" ? "\"".concat(value, "\"") : value, ",");
    }).join("\n");
    errors.push(outdent__default.default(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n        Recommended ", " compilerOptions missing:\n\n        The following fields had unexpected values: [", "]\n        Expected to find these values:\n        ", "\n\n        Please update your ", " accordingly.\n      "])), tsconfig, wrongEntries.map(_ref11 => {
      let [key] = _ref11;
      return key;
    }).join(", "), expectedOutput, tsconfig).trimStart());
  }
  return errors;
}
function validatePkgUtilsDependency(_ref12) {
  let {
    devDependencies
  } = _ref12;
  if (!(devDependencies == null ? void 0 : devDependencies["@sanity/pkg-utils"])) {
    return [outdent__default.default(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n        package.json does not list @sanity/pkg-utils as a devDependency.\n        @sanity/pkg-utils replaced parcel as the recommended build tool in @sanity/plugin-kit 2.0.0\n\n        Please add it by running 'npm install --save-dev @sanity/pkg-utils'.\n    "]))).trimStart()];
  }
  return [];
}
function validateSanityDependencies(packageJson) {
  const {
    dependencies,
    devDependencies,
    peerDependencies
  } = packageJson;
  const allDependencies = _objectSpread(_objectSpread(_objectSpread({}, dependencies), devDependencies), peerDependencies);
  const illegalDeps = Object.keys(allDependencies).filter(dep => mergedPackages.includes(dep));
  const deps = new Set(illegalDeps);
  const unique = [...deps.values()];
  if (unique.length) {
    return [outdent__default.default(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n        package.json depends on \"@sanity/*\" packages that have moved into \"sanity\" package.\n\n        The following dependencies should be replaced with \"sanity\":\n        - ", "\n\n        Refer to the reference docs to find replacement imports:\n        ", "\n    "])), unique.join("\n- "), cli.urls.refDocs).trimStart()];
  }
  return [];
}
function validateDeprecatedDependencies(packageJson) {
  const {
    dependencies,
    devDependencies,
    peerDependencies
  } = packageJson;
  const allDependencies = _objectSpread(_objectSpread(_objectSpread({}, dependencies), devDependencies), peerDependencies);
  const illegalDeps = Object.keys(allDependencies).filter(dep => deprecatedDevDeps.includes(dep));
  const deps = new Set(illegalDeps);
  const unique = [...deps.values()];
  if (unique.length) {
    return [outdent__default.default(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n        package.json contains deprecated dependencies that should be removed:\n        - ", "\n    "])), unique.join("\n- ")).trimStart()];
  }
  return [];
}
async function validateBabelConfig(_ref13) {
  let {
    basePath
  } = _ref13;
  const babelConfig = await findBabelConfig__default.default(basePath);
  if (babelConfig.file) {
    return [outdent__default.default(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n        Found babel-config file: ", ". When using default @sanity/plugin-kit build command,\n        this is probably not needed.\n\n        Delete the ", " file, or disable this check.\n      "])), babelConfig.file, babelConfig.file).trimStart()];
  }
  return [];
}
async function validateStudioConfig(_ref14) {
  let {
    basePath
  } = _ref14;
  var _a, _b, _c, _d, _e;
  const suffixes = ["ts", "js", "tsx", "jsx"];
  const withSuffix = fileBases => fileBases.flatMap(file => suffixes.map(suffix => "".concat(file, ".").concat(suffix)));
  const filenames = withSuffix(["sanity.config", "sanity.cli"]);
  const files = {};
  for (const filename of filenames) {
    const filepath = path__default.default.normalize(path__default.default.join(basePath, filename));
    files[filename] = await fileExists(filepath);
  }
  const sanityJson = await readJson5File({
    basePath,
    filename: "sanity.json"
  });
  const hasConfigFile = fileBase => withSuffix([fileBase]).some(filename => files[filename]);
  const hasCliConfig = hasConfigFile("sanity.cli");
  const hasStudioConfig = hasConfigFile("sanity.config");
  const errors = [];
  if (sanityJson) {
    const info = [outdent__default.default(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n        Found sanity.json. This file is not used by Sanity Studio V3.\n\n        Please consult the Studio V3 migration guide:\n         ", "\n        It will detail how to convert sanity.json to sanity.config.ts (or .js) and sanity.cli.ts (or .js) equivalents.\n      "])), cli.urls.migrationGuideStudio).trimStart(), ((_a = sanityJson.plugins) == null ? void 0 : _a.length) && outdent__default.default(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral(["\n        For V3 versions and alternatives to V2 plugins, please refer to the Sanity Exchange:\n        ", "\n      "])), cli.urls.sanityExchange).trimStart()].filter(s => !!s);
    errors.push(info.join("\n\n"));
  }
  if (!hasCliConfig) {
    var _ref15, _ref16;
    errors.push(outdent__default.default(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral(["\n        sanity.cli.(", ") missing. Please create a file named sanity.cli.ts with the following content:\n\n        ", "\n\n        Make sure to replace the projectId and dataset fields with your own.\n\n        For more, see ", "\n    "])), suffixes.join(" | "), chalk__default.default.green(outdent__default.default(_templateObject13 || (_templateObject13 = _taggedTemplateLiteral(["\n        import {createCliConfig} from 'sanity/cli'\n\n        export default createCliConfig({\n          api: {\n            projectId: '", "',\n            dataset: '", "',\n          }\n        })"])), (_ref15 = (_b = sanityJson == null ? void 0 : sanityJson.api) == null ? void 0 : _b.projectId) !== null && _ref15 !== void 0 ? _ref15 : "project-id", (_ref16 = (_c = sanityJson == null ? void 0 : sanityJson.api) == null ? void 0 : _c.dataset) !== null && _ref16 !== void 0 ? _ref16 : "dataset")), cli.urls.migrationGuideStudio).trimStart());
  }
  if (!hasStudioConfig) {
    var _ref17, _ref18;
    errors.push(outdent__default.default(_templateObject14 || (_templateObject14 = _taggedTemplateLiteral(["\n        sanity.config.(", ") missing. At a minimum sanity.config.ts should contain:\n\n        ", "\n\n        Make sure to replace the projectId and dataset fields with your own.\n\n        For more, see ", "\n    "])), suffixes.join(" | "), chalk__default.default.green(outdent__default.default(_templateObject15 || (_templateObject15 = _taggedTemplateLiteral(["\n            import { defineConfig } from \"sanity\"\n            import { deskTool } from \"sanity/desk\"\n\n            export default defineConfig({\n              name: \"default\",\n\n              projectId: '", "',\n              dataset: '", "',\n\n              plugins: [\n                deskTool(),\n              ],\n\n              schema: {\n                types: [\n                  /* put your v2 schema-types here */\n                ],\n              },\n            })"])), (_ref17 = (_d = sanityJson == null ? void 0 : sanityJson.api) == null ? void 0 : _d.projectId) !== null && _ref17 !== void 0 ? _ref17 : "project-id", (_ref18 = (_e = sanityJson == null ? void 0 : sanityJson.api) == null ? void 0 : _e.dataset) !== null && _ref18 !== void 0 ? _ref18 : "dataset")).trimStart(), cli.urls.migrationGuideStudio).trimStart());
  }
  return errors.length ? [errors.join("\n\n---\n\n")] : [];
}
async function validatePluginSanityJson(_ref19) {
  let {
    basePath,
    packageJson
  } = _ref19;
  var _a, _b;
  const sanityJson = await readJson5File({
    basePath,
    filename: "sanity.json"
  });
  const expectedDefaults = {
    parts: [{
      implements: "part:@sanity/base/sanity-root",
      path: "./v2-incompatible.js"
    }]
  };
  const hasSinglePart = sanityJson && Object.keys(sanityJson).length === 1 && (sanityJson == null ? void 0 : sanityJson.parts) && sanityJson.parts.length === 1;
  const firstPart = hasSinglePart ? (_a = sanityJson == null ? void 0 : sanityJson.parts) == null ? void 0 : _a[0] : void 0;
  const correctImplements = (firstPart == null ? void 0 : firstPart.implements) === expectedDefaults.parts[0].implements;
  const pathExists = (firstPart == null ? void 0 : firstPart.path) && (await fileExists(path__default.default.normalize(path__default.default.join(basePath, firstPart.path))));
  const hasDependency = !!((_b = packageJson.dependencies) == null ? void 0 : _b[cli.incompatiblePluginPackage]);
  const isValid = sanityJson && hasSinglePart && correctImplements && pathExists && hasDependency;
  if (!isValid) {
    const errors = [!sanityJson ? "sanity.json does not exist" : null, !hasSinglePart ? 'sanity.json should have exactly one entry in "parts", but did not.' : null, !correctImplements ? "The part should implement ".concat(expectedDefaults.parts[0].implements, ", but did not.") : null, (firstPart == null ? void 0 : firstPart.path) && !pathExists ? "The file in \"path\", ".concat(firstPart == null ? void 0 : firstPart.path, ", does not exist.") : null, !hasDependency ? outdent__default.default(_templateObject16 || (_templateObject16 = _taggedTemplateLiteral(["\n      package.json should have ", " as a dependency, but did not.\n        Install it with: npm install --save ", "\n      "])), cli.incompatiblePluginPackage, cli.incompatiblePluginPackage).trimStart() : null].filter(e => !!e);
    return [outdent__default.default(_templateObject17 || (_templateObject17 = _taggedTemplateLiteral(["\n        Invalid sanity.json. It is used for compatibility checking in V2 studios:\n\n        - ", "\n\n        sanity.json will only be used when incorrectly installing a v3 plugin in a v2 Studio.\n\n        This check ensures that sanity.json conforms with the usage section of\n        ", "\n    "])), errors.join("\n- "), cli.urls.incompatiblePlugin).trimStart()];
  }
  return [];
}
function validatePackageName$1(packageJson) {
  var _a, _b;
  const valid = validateNpmPackageName__default.default(packageJson.name);
  if (!valid.validForNewPackages) {
    return ["Invalid package.json: \"name\" is invalid: ".concat(valid.errors.join(", "))];
  }
  const isScoped = (_a = packageJson.name) == null ? void 0 : _a.startsWith("@");
  if (!isScoped && !((_b = packageJson.name) == null ? void 0 : _b.startsWith("sanity-plugin-"))) {
    return ["Invalid package.json: \"name\" should be prefixed with \"sanity-plugin-\" (or scoped - @your-company/plugin-name)"];
  }
}
async function validateSrcIndexFile(basePath) {
  const paths = ["index.js", "index.ts"].map(p => path__default.default.join("src", p));
  const allowedIndexFiles = paths.map(file => path__default.default.join(basePath, file));
  let hasIndex = false;
  for (const indexFile of allowedIndexFiles) {
    hasIndex = hasIndex || (await fileExists(indexFile));
  }
  if (!hasIndex) {
    return [outdent__default.default(_templateObject18 || (_templateObject18 = _taggedTemplateLiteral(["\n      Expected one of [", "] to exist.\n\n      @sanity/pkg-utils expects a non-jsx file to be the source entry-point for the plugin.\n      If you currently have JSX in your index file, extract it into a separate file and import it.\n      "])), paths.join(", "))];
  }
  return [];
}
async function disallowDuplicateConfig(_ref20) {
  let {
    basePath,
    pkgJson,
    configKey,
    files
  } = _ref20;
  const found = [];
  for (const file of files) {
    const filePath = path__default.default.join(basePath, file);
    const exits = await fileExists(filePath);
    if (exits) {
      found.push(file);
    }
  }
  if (found.length > 1) {
    return [outdent__default.default(_templateObject19 || (_templateObject19 = _taggedTemplateLiteral(["\n      Found multiple config files that serve the same purpose: [", "].\n\n      There should be at most one of these files. Delete the rest.\n      "])), found.join(", "))];
  }
  if (found.length && pkgJson[configKey]) {
    return [outdent__default.default(_templateObject20 || (_templateObject20 = _taggedTemplateLiteral(["\n      package.json contains ", ", but there also exists a config file that serves the same purpose.\n      Config file: ", "]\n\n      Either delete the file or remove ", " entry from package.json.\n      "])), configKey, found.join(""), configKey)];
  }
  return [];
}
async function disallowDuplicateEslintConfig(basePath, pkgJson) {
  return disallowDuplicateConfig({
    basePath,
    pkgJson,
    configKey: "eslint",
    files: [".eslintrc", ".eslintrc.js", ".eslintrc.cjs", ".eslintrc.yaml", ".eslintrc.yml", ".eslintrc.json"]
  });
}
async function disallowDuplicatePrettierConfig(basePath, pkgJson) {
  return disallowDuplicateConfig({
    basePath,
    pkgJson,
    configKey: "prettier",
    files: [".prettierrc", ".prettierrc.json5", ".prettierrc.yaml", ".prettierrc.yml", ".prettierrc.js", ".prettierrc.cjs", ".prettier.config,js", ".prettier.config.cjs", ".prettierrc.toml"]
  });
}
const forcedPackageVersions = {};
const forcedDevPackageVersions = forcedPackageVersions;
const forcedPeerPackageVersions = {
  react: "^18",
  "react-dom": "^18",
  "react-is": "^18",
  "@types/react": "^18",
  "@types/react-dom": "^18",
  sanity: "^3",
  "styled-components": "^5.2"
};
const defaultDependencies = [cli.incompatiblePluginPackage];
const defaultDevDependencies = ["npm-run-all", "rimraf", "sanity", "react", "react-dom", "styled-components", "react-is"];
const defaultPeerDependencies = ["react", "sanity"];
const readFile = util__default.default.promisify(fs__default.default.readFile);
const pathKeys = ["main", "module", "browser", "types", "typings"];
async function getPackage(opts) {
  const options = _objectSpread({
    flags: {}
  }, opts);
  validateOptions(options);
  const {
    basePath,
    validate = true
  } = options;
  const manifestPath = path__default.default.normalize(path__default.default.join(basePath, "package.json"));
  let content;
  try {
    content = await readFile(manifestPath, "utf8");
  } catch (err) {
    if (err.code === "ENOENT") {
      throw new Error("No package.json found. package.json is required to publish to npm. Use `".concat(cli.cliName, " init` for a new plugin, or `npm init` for an existing one"));
    }
    throw new Error("Failed to read \"".concat(manifestPath, "\": ").concat(err.message));
  }
  let parsed;
  try {
    parsed = JSON.parse(content);
  } catch (err) {
    throw new Error("Error parsing \"".concat(manifestPath, "\": ").concat(err.message));
  }
  if (!isObject(parsed)) {
    throw new Error("Invalid package.json: Root must be an object");
  }
  if (validate) {
    await validatePackage(parsed, options);
  }
  return parsed;
}
async function validatePackage(manifest, opts) {
  validateOptions(opts);
  const options = _objectSpread({
    isPlugin: true
  }, opts);
  if (options.isPlugin) {
    await validatePluginPackage(manifest, options);
  }
  validateLockFiles(options);
}
function validateOptions(opts) {
  const options = opts || {};
  if (!isObject(options)) {
    throw new Error("Options must be an object");
  }
  if (typeof options.basePath !== "string") {
    throw new Error("\"options.basePath\" must be a string (path to plugin base path)");
  }
}
async function validatePluginPackage(manifest, options) {
  validatePackageName(manifest);
  await validatePaths(manifest, options);
}
function validatePackageName(manifest) {
  if (typeof manifest.name !== "string") {
    throw new Error("Invalid package.json: \"name\" must be a string");
  }
  const valid = validateNpmPackageName__default.default(manifest.name);
  if (!valid.validForNewPackages) {
    throw new Error("Invalid package.json: \"name\" is invalid: ".concat(valid.errors.join(", ")));
  }
  const isScoped = manifest.name[0] === "@";
  if (!isScoped && !manifest.name.startsWith("sanity-plugin-")) {
    throw new Error("Invalid package.json: \"name\" should be prefixed with \"sanity-plugin-\" (or scoped - @your-company/plugin-name)");
  }
}
async function validatePaths(manifest, options) {
  var _manifest$name;
  var _a;
  const paths = await getPaths(_objectSpread(_objectSpread({}, options), {}, {
    pluginName: (_manifest$name = manifest.name) !== null && _manifest$name !== void 0 ? _manifest$name : "unknown",
    verifySourceParts: false,
    verifyCompiledParts: false
  }));
  const abs = file => path__default.default.isAbsolute(file) ? file : path__default.default.resolve(path__default.default.join(options.basePath, file));
  const exists = file => fs__default.default.existsSync(abs(file));
  const willExist = file => paths && hasSourceEquivalent(abs(file), paths);
  const withinSourceDir = file => (paths == null ? void 0 : paths.source) && abs(file).startsWith(paths.source);
  const withinTargetDir = file => (paths == null ? void 0 : paths.compiled) && abs(file).startsWith(paths.compiled);
  for (const key of pathKeys) {
    if (!(key in manifest)) {
      continue;
    }
    const manifestValue = manifest[key];
    if (typeof manifestValue !== "string") {
      throw new Error("Invalid package.json: \"".concat(key, "\" must be a string if defined"));
    }
    if (!((_a = options == null ? void 0 : options.flags) == null ? void 0 : _a.allowSourceTarget) && paths && withinSourceDir(manifestValue)) {
      throw new Error("Invalid package.json: \"".concat(key, "\" points to file within source (uncompiled) directory. Use --allow-source-target if you really want to do this."));
    }
    const fileExists = exists(manifestValue);
    if (fileExists && paths && withinTargetDir(manifestValue) && !(await willExist(manifestValue))) {
      throw new Error("Invalid package.json: \"".concat(key, "\" points to file that will not exist after compiling"));
    }
    if (!exists(manifestValue) && !(await willExist(manifestValue))) {
      if (!paths) {
        throw new Error("Invalid package.json: \"".concat(key, "\" points to file that does not exist"));
      }
      const inOutDir = paths.compiled && !abs(manifestValue).startsWith(paths.compiled);
      throw new Error(inOutDir ? "Invalid package.json: \"".concat(key, "\" points to file that does not exist, and \"paths\" is not configured to compile to this location") : "Invalid package.json: \"".concat(key, "\" points to file that does not exist, and no equivalent is found in source directory"));
    }
  }
}
function isObject(obj) {
  return !Array.isArray(obj) && obj !== null && typeof obj === "object";
}
function validateLockFiles(options) {
  const npm = fs__default.default.existsSync(path__default.default.join(options.basePath, "package-lock.json"));
  const yarn = fs__default.default.existsSync(path__default.default.join(options.basePath, "yarn.lock"));
  if (npm && yarn) {
    throw new Error("Invalid plugin: contains both package-lock.json and yarn.lock");
  }
}
async function writePackageJson(data, options) {
  var _prev$version, _prev$keywords;
  const {
    user,
    pluginName,
    license,
    description,
    pkg: prevPkg,
    gitOrigin
  } = data;
  const {
    outDir,
    peerDependencies: addPeers,
    dependencies: addDeps,
    devDependencies: addDevDeps
  } = options;
  const {
    flags
  } = options;
  const prev = prevPkg || {};
  const usePrettier = flags.prettier !== false;
  const useEslint = flags.eslint !== false;
  const useTypescript = flags.eslint !== false;
  const newDevDependencies = [cli.cliName, "@sanity/pkg-utils"];
  if (useTypescript) {
    cli.log.debug("Using TypeScript. Adding to dev dependencies.");
    newDevDependencies.push("@types/react", "typescript");
  }
  if (usePrettier) {
    cli.log.debug("Using prettier. Adding to dev dependencies.");
    newDevDependencies.push("prettier", "prettier-plugin-packagejson");
  }
  if (useEslint) {
    cli.log.debug("Using eslint. Adding to dev dependencies.");
    newDevDependencies.push("eslint", "eslint-config-sanity", "eslint-plugin-react", "eslint-plugin-react-hooks");
    if (usePrettier) {
      newDevDependencies.push("eslint-config-prettier", "eslint-plugin-prettier");
    }
    if (useTypescript) {
      newDevDependencies.push("@typescript-eslint/eslint-plugin", "@typescript-eslint/parser");
    }
  }
  cli.log.debug("Resolving latest versions for %s", newDevDependencies.join(", "));
  const dependencies = forceDependencyVersions(_objectSpread(_objectSpread(_objectSpread({}, prev.dependencies || {}), addDeps || {}), await resolveLatestVersions(defaultDependencies)), forcedPackageVersions);
  const devDependencies = forceDependencyVersions(_objectSpread(_objectSpread(_objectSpread({}, addDevDeps || {}), prev.devDependencies || {}), await resolveLatestVersions([...newDevDependencies, ...defaultDevDependencies])), forcedDevPackageVersions);
  const peerDependencies = forceDependencyVersions(_objectSpread(_objectSpread(_objectSpread({}, prev.peerDependencies || {}), addPeers || {}), await resolveLatestVersions(defaultPeerDependencies)), forcedPeerPackageVersions);
  const source = flags.typescript ? "./src/index.ts" : "./src/index.js";
  const files = [outDir, "sanity.json", "src", "v2-incompatible.js"];
  files.sort();
  const forcedOrder = _objectSpread(_objectSpread(_objectSpread(_objectSpread({
    name: pluginName,
    version: (_prev$version = prev.version) !== null && _prev$version !== void 0 ? _prev$version : "1.0.0",
    description: description || "",
    keywords: (_prev$keywords = prev.keywords) !== null && _prev$keywords !== void 0 ? _prev$keywords : ["sanity", "sanity-plugin"]
  }, urlsFromOrigin(gitOrigin)), repoFromOrigin(gitOrigin)), {}, {
    license: license ? license.id : "UNLICENSED",
    author: (user == null ? void 0 : user.email) ? "".concat(user.name, " <").concat(user.email, ">") : user == null ? void 0 : user.name,
    exports: {
      ".": _objectSpread(_objectSpread({}, flags.typescript ? {
        types: "./".concat(outDir, "/index.d.ts")
      } : {}), {}, {
        source,
        import: "./".concat(outDir, "/index.esm.js"),
        require: "./".concat(outDir, "/index.js"),
        default: "./".concat(outDir, "/index.esm.js")
      }),
      "./package.json": "./package.json"
    },
    main: "./".concat(outDir, "/index.js"),
    module: "./".concat(outDir, "/index.esm.js"),
    source
  }, flags.typescript ? {
    types: "./".concat(outDir, "/index.d.ts")
  } : {}), {}, {
    files,
    scripts: _objectSpread({}, prev.scripts),
    dependencies: sortKeys(dependencies),
    devDependencies: sortKeys(devDependencies),
    peerDependencies: sortKeys(peerDependencies),
    engines: {
      node: ">=14"
    }
  });
  const manifest = _objectSpread(_objectSpread(_objectSpread({}, forcedOrder), prev || {}), forcedOrder);
  delete manifest.typings;
  const differs = JSON.stringify(prev) !== JSON.stringify(manifest);
  cli.log.debug("Does manifest differ? %s", differs ? "yes" : "no");
  if (differs) {
    await writePackageJsonDirect(manifest, options);
  }
  return differs ? manifest : prev;
}
function urlsFromOrigin(gitOrigin) {
  const details = githubUrlToObject__default.default(gitOrigin);
  if (!details) {
    return {};
  }
  return {
    homepage: "https://github.com/".concat(details.user, "/").concat(details.repo, "#readme"),
    bugs: {
      url: "https://github.com/".concat(details.user, "/").concat(details.repo, "/issues")
    }
  };
}
function repoFromOrigin(gitOrigin) {
  console.log(gitOrigin);
  if (!gitOrigin) {
    return {};
  }
  return {
    repository: {
      type: "git",
      url: gitOrigin
    }
  };
}
function addScript(cmd, existing) {
  if (existing && existing.includes(cmd)) {
    return existing;
  }
  return cmd;
}
async function addPackageJsonScripts(manifest, options, updateScripts) {
  const originalScripts = manifest.scripts || {};
  const scripts = updateScripts(_objectSpread({}, originalScripts));
  const differs = Object.keys(scripts).some(key => scripts[key] !== originalScripts[key]);
  if (differs) {
    await writePackageJsonDirect(_objectSpread(_objectSpread({}, manifest), {}, {
      scripts
    }), options);
  }
  return differs;
}
async function writePackageJsonDirect(manifest, _ref21) {
  let {
    basePath
  } = _ref21;
  await writeJsonFile(path__default.default.join(basePath, "package.json"), manifest);
}
async function addBuildScripts(manifest, options) {
  const {
    outDir
  } = options;
  if (!options.flags.scripts) {
    return false;
  }
  return addPackageJsonScripts(manifest, options, scripts => {
    scripts.build = addScript(expectedScripts.build, scripts.build);
    scripts.clean = addScript("rimraf ".concat(outDir), scripts.clean);
    scripts.format = addScript("prettier --write --cache --ignore-unknown .", scripts.format);
    scripts["link-watch"] = addScript(expectedScripts["link-watch"], scripts["link-watch"]);
    scripts.lint = addScript("eslint .", scripts.lint);
    scripts.prepublishOnly = addScript(expectedScripts.prepublishOnly, scripts.prepublishOnly);
    scripts.watch = addScript(expectedScripts.watch, scripts.watch);
    return scripts;
  });
}
function sortKeys(unordered) {
  return Object.keys(unordered).sort().reduce((obj, key) => {
    obj[key] = unordered[key];
    return obj;
  }, {});
}
function forceDependencyVersions(deps) {
  let versions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : forcedPackageVersions;
  const entries = Object.entries(deps).map(entry => {
    const [pkg] = entry;
    const forceVersion = versions[pkg];
    if (forceVersion) {
      return [pkg, forceVersion];
    }
    return entry;
  });
  return Object.fromEntries(entries);
}
exports.addBuildScripts = addBuildScripts;
exports.addPackageJsonScripts = addPackageJsonScripts;
exports.addScript = addScript;
exports.copyFileWithOverwritePrompt = copyFileWithOverwritePrompt;
exports.disallowDuplicateEslintConfig = disallowDuplicateEslintConfig;
exports.disallowDuplicatePrettierConfig = disallowDuplicatePrettierConfig;
exports.ensureDir = ensureDir;
exports.errorToUndefined = errorToUndefined;
exports.fileExists = fileExists;
exports.findStudioV3Config = findStudioV3Config;
exports.forceDependencyVersions = forceDependencyVersions;
exports.forcedDevPackageVersions = forcedDevPackageVersions;
exports.forcedPackageVersions = forcedPackageVersions;
exports.getPackage = getPackage;
exports.hasSanityJson = hasSanityJson;
exports.isEmptyish = isEmptyish;
exports.mergedPackages = mergedPackages;
exports.mkdir = mkdir;
exports.prompt = prompt;
exports.promptForPackageName = promptForPackageName;
exports.promptForRepoOrigin = promptForRepoOrigin;
exports.readFile = readFile$2;
exports.readJsonFile = readJsonFile;
exports.resolveLatestVersions = resolveLatestVersions;
exports.sortKeys = sortKeys;
exports.validateBabelConfig = validateBabelConfig;
exports.validateDeprecatedDependencies = validateDeprecatedDependencies;
exports.validateModule = validateModule;
exports.validateNodeEngine = validateNodeEngine;
exports.validatePackageName = validatePackageName$1;
exports.validatePkgUtilsDependency = validatePkgUtilsDependency;
exports.validatePluginSanityJson = validatePluginSanityJson;
exports.validateSanityDependencies = validateSanityDependencies;
exports.validateScripts = validateScripts;
exports.validateSrcIndexFile = validateSrcIndexFile;
exports.validateStudioConfig = validateStudioConfig;
exports.validateTsConfig = validateTsConfig;
exports.writeFile = writeFile;
exports.writeFileWithOverwritePrompt = writeFileWithOverwritePrompt;
exports.writePackageJson = writePackageJson;
exports.writePackageJsonDirect = writePackageJsonDirect;
//# sourceMappingURL=package-bdb22a22.js.map
