'use strict';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var meow = require('meow');
var _package = require('./package-f79f12a7.js');
var cli = require('./cli-dbe00b65.js');
function _interopDefaultCompat(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    default: e
  };
}
var meow__default = /*#__PURE__*/_interopDefaultCompat(meow);
const description = "Show the installed version of ".concat(_package.pkg.name);
const help = "\nUsage\n  $ ".concat(_package.pkg.binname, " version\n\nOptions\n  --major  Show only the major version\n  --minor  Show only the minor version\n  --patch  Show only the patch version\n\nExamples\n  $ ").concat(_package.pkg.binname, " version\n  ").concat(_package.pkg.name, " version ").concat(_package.pkg.version, "\n\n  $ ").concat(_package.pkg.binname, " version --major\n  ").concat(_package.pkg.version.split(".")[0], "\n");
const flags = _objectSpread(_objectSpread({}, cli.sharedFlags), {}, {
  major: {
    type: "boolean",
    default: false
  },
  minor: {
    type: "boolean",
    default: false
  },
  patch: {
    type: "boolean",
    default: false
  }
});
function run(_ref) {
  let {
    argv
  } = _ref;
  const cli$1 = meow__default.default(help, {
    flags,
    argv,
    description
  });
  const versionParts = _package.pkg.version.split(".");
  const versionNames = ["major", "minor", "patch"];
  const versionFlags = versionNames.filter(flagName => cli$1.flags[flagName]);
  const versionFlag = versionFlags[0];
  const numVersionFlags = versionFlags.length;
  if (numVersionFlags === 0) {
    cli.log.msg("".concat(_package.pkg.name, " version ").concat(_package.pkg.version));
    return;
  }
  if (numVersionFlags > 1) {
    throw new Error("--major, --minor and --patch are mutually exclusive - only one can be used at a time");
  }
  const partIndex = versionNames.indexOf(versionFlag);
  cli.log.msg(versionParts[partIndex]);
}
exports.default = run;
//# sourceMappingURL=version-f89917d7.js.map
